
' Asmoshphere
' 14:23 01/04/2008
' 22:47 15/04/2008 to SSE4
' 04:25 23/04/2008 fix hexadecimal literals. Local #variable overrides
' 03:44 30/04/2008 softcoding + hash lookup
' Charles E V Pegge

#ifndef ert
    dim shared as long   ert 'error number
    dim shared as string ers ' error text
#endif

dim shared as long bgl ' beginning of current line
dim shared as long lct ' line count
dim shared as long vew ' complile mode
' 0 normal
' 1 Stop at first error
' 2 include source as comment with errors messages appended to the line

dim shared as string macs(1000,1) ' buffer for macro efs
dim shared as long   scop(100)    ' nesting scope index
dim shared as long me ' macro list end boundary
dim shared as long mp ' macro iteration index
dim shared as long mct ' macro anti recursion counter
dim shared as long mex ' macro anti recursion source buffer limit
dim shared as long mck ' eanable detection of unmarked macro call (without $)
dim shared as long swd ' start of current word

dim shared as long   opd(999,9), ope
dim shared as string opn(999),ops(999)

const cr as string =chr$(13)+chr$(10)


function Report_Error() as string
    function=ers
end function


'LOWER CASE ASCII
function asclc(s as string,i as long) as long
    dim as long a
    a=asc(s,i)
    if (a>64)and(a<91) then a+=32
    function=a
end function

'CONVERT TO TEXT HEX BYTE
function hexb(v as long) as string
    function=" "+right$("0"+hex$(v and &hff),2)
end function

' CONVERT TO TEXT HEX WORD
function hexw(v as long) as string
    dim s as string
    s=right$("000"+hex$(v),4)
    function=" "+right$(s,2)+" "+left$(s,2)
end function


'CONVERT TO TEXT HEX DWORD
function hexl(v as long) as string
    dim s as string
    s=right$("0000000"+hex$(v),8)
    function=" "+right$(s,2)+" "+mid$(s,5,2)+" "+mid$(s,3,2)+" "+left$(s,2)
end function




'===========================================================
' WORD
'===========================================================


'GET NEXT WORD + EXPAND MACROS
function word(byref s as string, byref i as long) as string
' s    source
' i    position in source
' swd  start of word position
' a    ascii code
' b    general purpose
' k    general purpose
' wr   word


    dim as long a,b,k
    dim as string wr

wredo:
    do ' skip leading white space and blank lines
        a=asc(s,i)
        if a=0 then exit do
        'if a=10 then lct+=1
        if a>32 then exit do
        i+=1
    loop
    swd=i
    do
        a=asc(s,i)
        if a>96 then i+=1:continue do
        if a<32 then exit do
        if a<33 then exit do
        if (a=96)or(a=34) then
            b=a
            do
                i+=1
                a=asc(s,i)
                if (a=b)or(a=0) then i+=1: exit do
            loop
            exit do
        end if
        if a=35 then i+=1:continue do
        if (a<48)or(a=91)or(a=93)or(a=59)or(a=61)or(a=96)or(a=58) then
            if i=swd then k=1:i+=1
            exit do
        end if 
        i+=1
    loop
    #ifdef CASE_INSENSITIVE
        if b=0 then wr=lcase$(mid$(s,swd,i-swd))
        if b<>0 then wr=mid$(s,swd,i-swd)
    #else 
         wr=mid$(s,swd,i-swd)
    #endif
    if ((a=36)or(mck=1))and(k=0) then ' macro$ 
        mct+=1:mck=0
        if (mct>=&h100)or(len(s)>mex) then ert=102:goto exitword
        mp=me
        do
            mp-=1
            if mp<0 then exit do
            if wr=macs(mp,0) then
                b=0:if a=36 then b=1
                s=macs(mp,1)+mid$(s,i+b)
                bgl=1:i=1:k=0:b=0:mck=2
                goto wredo 'destructive to src
            end if
        loop
        if a=36 then ert=101 ' $ macro not found otherwise silent with mck flag
    end if
    do ' skip following white space
        a=asc(s,i)
        if a<=13 then exit do
        if a>32 then exit do
        i+=1
    loop
    exitword:
    function=wr
end function


'=======================================================================


'GET VALUE OF WORD (INCLUDING FLOATING POINT AND E NOTATION)
sub wordval(s as string,st as long, byref i as long, byref dv as double)
    dim as string wd,ps
    dim as long a,pt,sg,de
    i=st
    a=asc(s,i)
    if (a<45)or(a>57)or(a=&h2f) then wd=word(s,i):dv=0:exit sub ' not a number
    if a=45 then i+=1:a=asc(s,i):sg=1
    if a=48 then 
        i+=1:a=asclc(s,i)
        if (a=&h6f)or(a=&h78) then
            i+=1
            wd=word(s,i)
            if wd="-" then sg=1:wd=word(s,i)
            if a=&h6f then wd="&o"+wd
            if a=&h78 then wd="&h"+wd
            dv=val(wd)
            if sg then dv=-dv
            exit sub
        end if
    end if
    if a=46 then i+=1: pt=1
    sg=1 'inhib -
    do
        a=asclc(s,i)
        if a=46 then
            if pt=1 then ert=25:goto exwordval
            pt=1:i+=1: continue do
        end if
        if a=45 then
            if sg=1 then ert=26:goto exwordval
            sg=1:i+=1:continue do
        end if
        if (a=&h45)or(a=&h65) then
            if de=1 then ert=27: goto exwordval
            sg=0:de=1:pt=1:i+=1:continue do 'E
        end if
        if (a<48)or(a>57) then exit do
        i+=1
    loop
exwordval:
    wd=mid$(s,st,i-st)
    dv=val(wd)   
end sub

'=======================================================================


function adrcode(s as string) as long
    dim as long b
    dim as any ptr c
    b=len(s):c=strptr(s)
    asm
    mov ecx, [b]
    mov edx, [c]
    mov ah,  [b]     ' length
    mov al,  [edx]   ' 1st letter
    shl eax, 8
    mov al,  [edx+1] ' 2nd letter
    shl eax,8
    hlo:
        rol eax,1
        xor al, [edx]
        inc edx
        dec ecx
    jg hlo
    mov [function],eax
    end asm 
end function



function lookupc(wd as string) as long
    dim as long v,i
    i=adrcode(wd):v=i and 511
    if i=-1 then
        ert=9:ers="Illegal hash: "+wd ' very low probability event
        function=-1:exit function
    end if
    do
        if opd(v,9)=i then ' match#
            'if wd=opn(v) then exit do ' success matching words
            exit do ' success 32 bit match #
        end if
        v=opd(v,8)
        if v=-1 then ert=9:ers="Unidentified instruction in chain: "+wd:exit do ' not found
    loop
    function=v
end function



sub loadops()
    dim as long a,i,j,k,v,f,n
    dim as string s,wd
    f=freefile
    err=0
    open "o2asm.data" for input as f
    if err then ers="Problem accessing o2asm.data": ert=9: exit sub
    ope=0
    n=512
    k=cast(long,@opd(0,0))
    asm
    mov edx,[k]
    mov ecx,9000
    mov eax,-1
    inil:
        mov [edx],eax
        add edx,4
        dec ecx
    jge inil
    end asm
    do
       if eof(f) then exit do
       line input #f, s
       i=1
       wd=word(s,i)
       if asc(wd)=39 then continue do ' comment
       if wd="" then continue do
       v=adrcode(wd): ope=v and 511
       'print wd,ope
       if len(opn(ope))>0 then
           'print "Chain: "+wd
           do
               'print "link",opn(ope)
               if opd(ope,8)=-1 then opd(ope,8)=n:ope=n:n+=1:exit do
               ope=opd(ope,8)
           loop
           if n>999 then ers="Too many instruction definitions":ert=9: exit sub
       end if
       opn(ope)=wd
       opd(ope,9)=v ' 32 bit #
       'print ope, wd, hex$(v)
       k=-1
       do
           k+=1: if k>7 then exit do
           wd=word(s,i)
           a=asc(wd)
           if a<=13 then exit do
           if a=34 then k-=1:ops(ope)=mid$(wd,2,len(wd)-2):continue do
           if a=43 then wd=word(s,i):k=7:a=asc(wd) '3dnow postfix code
           if a=45 then continue do ' leave default -1
           if a=39 then exit do ' comment
           opd(ope,k)=val("&h"+wd)
           ' ops prefix codes
           ' opd flags and opcodes
           ' k=0 flt
           ' k=1 pn
           ' k=2 b1
           ' k=3 c
           ' k=4 ima
           ' k=5 im
           ' k=6 ic
           ' k=7 dn
           ' k=8 lk link index
           ' k=9 32bit name #
       loop
    loop
    ' coincidence check
    i=-1
    do
        i+=1:if i>=n then exit do
        if opd(i,8)=-1 then continue do
        j=i
        do
            j+=1:if j>=n then exit do
            if opd(j,8)=-1 then continue do
            if opd(i,9)=opd(j,9) then
                ert=9:ers="!! instruction hash not unique: "+opn(i)+" "+opn(j)+" "+hex$(opd(j,9))
            end if
        loop
    loop
    'ert=9:ers="error test"
    'print "Extra ",n-512
end sub

'INTERPRET PROG CONTROL WORDS FOR JMP, CALL 
function jword(s as string ,st as long, byref i as long, byref lw as long) as string
' eg:
'    jmp long repeat
'    jmp repeat
'    call label

    dim as string wd
    dim as double v
    i=st
    wd=word(s,i)
    'if wd="#" then wd+=word(s,i):goto xitj
    if wd="long" then lw=1:wd=word(s,i)
    if wd="short" then lw=0:wd=word(s,i)
    'if wd="#" then wd+=word(s,i)
    wordval(s,swd,i,v)
    if (v<>0)or(asc(wd)=48) then
        ' immediate
        if lw=1 then wd=hexl(v):goto xitj
        if lw=0 then wd=hexb(v):goto xitj
    end if
    if wd="exit" then
        wd="x": if lw then wd+="l"
        goto xitj
    end if
    if wd="repeat" then 
        wd="r": if lw then wd+="l"
        goto xitj
    end if
    if lw then wd="gl "+wd:goto xitj
    wd="g "+wd:goto xitj
xitj:
    function=" "+wd
end function


'=======================================================================

'DETECT XMMX OR MMX REGISTER
function xmmxid( byval w as string, byref ds as long) as long
    dim as long a=asc(w),b=1,e=len(w)
    ds=0:function=-1
    if (a<97)or(e>4)or(e<3) then exit function
    if a=&h78 then ds=1:b+=1
    if (asc(w,b)<>&h6d)or(asc(w,b+1)<>&h6d) then exit function
    a=asc(w,e)-48
    if(a>=0)and(a<8) then function=a
end function

'DETECT GENERAL PURPOSE REGISTER
function regid( byref s as string, byref ds as long) as long
    dim as long a=asc(s),b=1,e=len(s),rg=-1,lo=2
    dim as string w
    ds=0:function=-1
    if (a<97)or(e<2)or(e>3) then exit function
    if a=&h65 then lo=4:w=mid$(s,2) else w=s
    if w="ax" then rg=0
    if w="cx" then rg=1
    if w="dx" then rg=2
    if w="bx" then rg=3
    if w="sp" then rg=4
    if w="bp" then rg=5
    if w="si" then rg=6
    if w="di" then rg=7
    if rg>=0 then
       ds=lo:function=rg
       exit function
    end if
    if lo=4 then exit function
    if w="al" then rg=0
    if w="cl" then rg=1
    if w="dl" then rg=2
    if w="bl" then rg=3
    if w="ah" then rg=4
    if w="ch" then rg=5
    if w="dh" then rg=6
    if w="bh" then rg=7
    if rg>=0 then ds=1:function=rg:exit function
    ds=0:function=rg
end function

'DETECT CONTROL,DEBUG AND SGMENT REGISTERS
function sregid( byref w as string, byref ds as long) as long
    dim as long rg=-1
    ds=0
    if (asc(w)<97)or(len(w)>3) then function=rg:exit function
    if w="cr0" then rg=0
    if w="cr2" then rg=1
    if w="cr3" then rg=2
    if w="cr4" then rg=3
    if rg>=0 then ds=129:function=rg:exit function
    if w="dr0" then rg=0
    if w="dr1" then rg=1
    if w="dr2" then rg=2
    if w="dr3" then rg=3
    if w="dr4" then rg=4
    if w="dr5" then rg=5
    if w="dr6" then rg=6
    if w="dr7" then rg=7
    if rg>=0 then ds=130:function=rg:exit function
    if w="es" then rg=0
    if w="cs" then rg=1
    if w="ss" then rg=2
    if w="ds" then rg=3
    if w="fs" then rg=4
    if w="gs" then rg=5
    if rg>=0 then ds=131:function=rg:exit function
    ds=0:function=rg
end function


'CAPTURE BRACKETED SOURCE CODE OR GENERAL TEXT
sub capture(byref s as string, byref m as long, byref i as long,byref c as long)
' s source string
' m beginning of capture (o)
' i source index (io)
' c beginning ascci char code
' v nesting depth counter
' k nesting flag
' a scii code
dim as long v,k,a
    do
      a=asc(s,i): if (a>32)or(a<1) then exit do
      i+=1
    loop
    m=i
    c=asc(s,m)
    if c=40 then v=1:i+=1:k=1
    do
        a=asc(s,i)
        if k=0 then
            if (a<=13)or(a=39)or(a=59) then exit do
        end if
        if k=1 then
            if a=40 then v+=1
            if a=41 then v-=1:if v<=0 then i+=1: exit do
            if a=0 then
                if v>0 then ert=10:exit sub
            end if
        end if
        i+=1
    loop
end sub





'=======================================
'PREPROCESSOR
'=======================================


'RESOLVE HIGH LEVEL EXPRESSION, MACROS ETC INTO ASSEMBLER
sub preprocess(byref s as string, byref t as string)
' s     source string
' t     output string
' fp    include string index
' qf    inline quote flag
' bg    beginning of current line
' nl    new line flag (used to check for colon labels)
' i     source index
' j     output index
' sst() source string buffers for include
' a     general ascii value
' k     general purpose
' m     general purpose
' v     general purpose
' wd    word string
' wr    word string
' co    code string
' asg   assignment string to appent post append to expression
'
t=space$(len(s)+1000)
dim as long fp
dim as string sst(100)
dim as long a,b,i,j,k,m,v,qf,bg,nl
dim as string wr,wd,co,asg
i=1:j=1
ert=0:ers=""
me=0:mp=0
bg=1:nl=1
mex=len(s)*10

do
    mct=0
    mck=1:wr=word(s,i):if ert then goto exitap
    a=asc(wr)


'COMMENTS

    if (a=39)or(a=59) then
        'find end of line
        k=swd
        do
            a=asc(s,i)
            if a<=13 then exit do
            i+=1
        loop
        goto addsrc
    end if

'FIRST WORD CHECKS

'colon labels:

    ' change colon labels to dot labels
    b=asc(s,i)
    if (b=58)and(nl=1) then
        k=swd:wd=word(s,i):swd=k ' dump colon
        mid$(s,k)="."+wr:nl=0
        goto addsrc
    end if
    nl=0


'ASSIGNMENTS

    if a=61 then
        asg="mov "+mid$(t,bg,j-bg)+", eax": j=bg
        continue do
    end if

    if wr="skip" then
        ' wont be passed to assembler single line or multi line (...)
        capture(s,m,i,a): if ert then goto exitap
        continue do
    end if

'MACROS

    if wr="def" then
        b=swd
        wr=word(s,i)
        macs(me,0)=wr
        capture(s,m,i,a)
       if ert>0 then  ers="Def brackets not closed ((..) ":ert=10:goto exitap
       if me>1000 then ers="Too many defs":ert=10:me=1000: goto exitap
       if a=40 then m+=1:i-=1
        macs(me,1)=mid$(s,m,i-m):me+=1
        if a=40 then i+=1:m-=1
        'if vew=2 then
        '    a=i-b
        '    if len(t)<j+500+a then t+=space$(2000+a)
        '    mid$(t,j)="skip ("+mid$(s,b,a)+cr+")"+cr: j+=a+7
        'end if
        continue do
    end if ' end macro defs

'PROCEDURES (supports macro expansion and string literals)

    if wr="proc" then
        wd=word(s,i):a=asc(wd)
        m=swd
        if (a<97)and(a<>91) then ers="Requires procedure name or mem spec [..] ":ert=11:goto exitap
        if a=91 then
            do ' [..]
                i+=1
                a=asc(s,i)
                if (a=39)or(a=59)or(a<=13) then ers="Unclosed [.. clause after 'proc'":ert=10:goto exitap
                if a=93 then i+=1:wd=mid$(s,m,i-m):exit do
            loop
        end if
        wr="call "+wd
        do
            a=asc(s,i): if (a>32)or(a<=13) then exit do
            i+=1
        loop
        if a=40 then wd=word(s,i):a=asc(s,i) ' ignore (
        if a=41 then wd=word(s,i):a=asc(s,i):goto brpass ' ignore )
        if (a>13)and(a<>39)and(a<>59)and(a<>41) then
            do
                qf=0
                mck=1:wd=word(s,i)
                m=swd
                if ert>100 then goto exitap
                a=asc(wd)
                if a=96 then qf=1
                if a=91 then
                    k=1
                    do ' [..]
                        i+=1
                        a=asc(s,i)
                        if k=1 then
                            if (a=39)or(a=59)or(a<=13) then ers="Unclosed [.. clause in proc parameter":ert=10:goto exitap
                        end if
                        if a<=13 then exit do
                        if (a>32)and(k=0) then exit do ' skipping end space
                        if a=93 then wd=mid$(s,m,i-m+1):k=0
                    loop
                end if
                if qf=1 then
                    co=wd+cr+"push eax"+cr+co
                end if
                if qf=0 then co="push "+wd+cr+co ' reverse order
                a=asc(s,i)
                if a<>44 then exit do
                i+=1
            loop
        end if
        if a=41 then i+=1 ' ignore ')'  
brpass:
        if len(asg) then asg=cr+asg
        wr=co+wr+asg+" ' proc"+cr:asg="":co=""
        mid$(t,j)=wr:j+=len(wr):bg=j:nl=1
        continue do 
        'NB adds into line count
    end if ' end of procedures

'INCLUDE FILES

    if wr="include" then
        wd=word(s,i)
        if len(wd) then
            a=asc(wd)
            k=len(wd)
            if (a=34)or(a=96) then k-=2:wd=mid$(wd,2,k) ' extract file name
            if fp>100 then ers="Too many 'include' files "+wd:ert=40:goto exitap
            sst(fp)=mid$(s,i)
            v=freefile
            open wd for binary access read as v
            s=space(lof(v))
            i=1
            get$ #v,,s
            close v
            if s="" then
                ers="Problem with file: "+wd:ert=40
               goto exitap
            end if 
            fp+=1                    
        end if
        continue do
    end if



addsrc:
    a=asc(s,i)
    if a=13 then i+=2
    if a=10 then i+=1
    mid$(t,j)=mid$(s,swd,i-swd):j+=i-swd ' given spacing, line breaks etc
    if a<=13 then bg=j:nl=1
    if len(t)<j+500 then t+=space$(2000)
    if a=0 then 
        if fp=0 then exit do ' end of string
        ' return from include
        fp-=1 ' resume previous source string
        i=1:bg=1
        s=sst(fp)
    end if
loop
exitap:
if ert=101 then ers="Macro undefined or out of scope:  "+wr
if ert=102 then ers="Macro recursion suspected:  "+wr
t=left$(t,j-1)
end sub



'==================================================================================================='
'MAIN ASSEMBLER
'==================================================================================================='





function Assemble(byref sr as string, byref i as long )  as string
' sr   preprocessor source
' s    assembler source
' t    assembler output
' i    source index
' j    output index
' m    general match index
' n    general purpose
' v    general purpose
' w    general purpose
' a    ascii code
' b    general purpose
' c    encoding (in rg position)
' d    general purpose
' wd   word
' wr   word
' co   code
' nn   operand length (like wk)
' sb   shortform byte code
' brc  bracket nesting counter
' l    general purpose length
' b0   main prefix code
' b1   main instruction code
' b2   address mode code
' dn   3dnow postfix
' md   mod component
' rg   reg component
' rm   rm component
' di   direction component
' im   immediate encoding
' ic   immediate encoding (in rg postion)
' pn   operand encoding constraint flag
' sg   sign flag
' ws   word size encoding
' wk   register size as bytes (also specialised regs 129 130 131)
' wk1  first operand size (from wk)
' se   sign extension encoding/flag
' axdi eax direct shortform encoding
' axim eax immediate shortform encoding
' ima  supports immediate operand flag
' lw   length of operand bytes in relative jumps / calls
' flt  instruction  class: gpu/fpu/mmx/simd/other
' bs   fpu mem operand encoding
' pp   fpu stack operand encoding
' cp   fpu stack operand encoding
' ppf  fpu pop flag
' et   fpu extended number encoding (for 10 byte number formats)
' qt   fpu operand size flag 
' itf  fpu integer instruction
' ads  address offset string
' dss  data code string
' re   register identifier (mem)
' sc   sib scal 
' id   sib index
' ptf  pointer flag
' rtf  return instruction flag
' rmf  
' rsf  bitscan instruction flag
' dv   double precision number (wordval return)
' rgm  reg rm encoding
' sib  sib byte encoding
' gg   mmx granularity encoding
' pfx  prefic codes as string

'SIGNALS:

' flt=0 genereal instruction
' flt=1 fpu instruction
' flt=2 mmx instruction
' flt=3 xmmx instruction
' flt=4 general instruction without di and ws additions
' pn=0  undefined
' pn=1  single operand
' pn=2  2 operands
' pn=3  2 operands - the first must be a register
' pn=4  2 operands - the first is an r/m, the second must be a register
' pn=5  2 operands -  the first must be a register
' pn=6  2 operands - the first must be a mem, not a register
' pn=7  1 operand  - must be a mem
' pn=8  undefined
' pn=9  undefined
' pn=10 3 operands - the third must be an 8 bit value eg some xmmx instructions
' pn=11 3 operands - the third must be an 8 bit value or the cl register eg: shld shrd
' pn=12 1 2 or 3 operands - specific to imul
' pn=13 1 or 2 operand bit shift shl ror etc
' pn=14 first reg is general purpose, second reg is xmmx, rg and rm octals are then swapped thus: md-rm-rg (PMOVMSKB)
' pn=15 r/m.xmm,imm8  (pextrb pextrw pextrd pextrq)

dim as long j,k,m,n,v,w,a,b,c,d
dim as string wd,wr,wp,co,pfx
dim as long nn,sb,brc,l
dim as long b0,b1,b2,dn,lp
dim as long md,rg,rm,er,di,im,pn,sg,ws,wk,wk1,se
dim as long axim,axdi
dim as long ima,ic,lw
dim as long flt,bs,pp,cp,ppf,et,qt,itf


dim as string ads,dss
dim as long re,ds,sc,id
dim as long ptf,rtf,rmf,rsf
dim as long rgm,sib
dim as double dv
dim as long gg


dim as string s,t

ert=0
ers=""
if ope=0 then loadops() ' loads once when required
if ert=0 then preprocess(sr,s)
if ert>0 then function="c3 ; "+ers:exit function
t=space$(len(s)+1000)
mex=len(t)*16

i=1
j=1
lct=1
ert=0
ers=""
b0=-1
b1=-1
b2=-1
dn=-1
lp=0
do ' main loop


    co=""
    b0=-1
    im=0
    di=0
    flt=0
    mct=0
    rsf=0
    pn=0
    'skip crlfs etc at beginning of line
    do
        a=asc(s,i)
        if a=10 then lct+=1
        if a=9 then a=32 ' tab
        if a>31 then exit do
        if a=0 then exit do ' end of string
        i+=1
    loop
    if a=0 then goto term
    bgl=i
    wr=word(s,i)
    a=asc(wr)
    if a=0 then goto term



'COMMENTS

    if (a=39)or(a=59) then ' ' ; comment
        i=bgl:goto flush
    end if



'STRING DATA STEPOVER ``

    if a=96 then '`` strings
        co=" E8 00 00 00 00"+cr+_
           " ( EB x"+cr+_
           chr$(34)+mid$(wr,2,len(wr)-2)+chr$(34)+" 00"+cr+_
           " )"+cr+_
           " 58 40 40"
        ' popped ptr to eax {messagebox}
        goto addcode
    end if


'PASS THROUGHS

        wd=" "+wr+" "

        m=0: if a=&h64 then  m=instr(" db dw dd ",wd) ' commas are optional
        if m>0 then
            do
                a=asc(s,i)
                do
                    a=asc(s,i)
                    if (a<=13)or(a=39)or(a=59) then goto addcode
                    if a>32 then exit do
                    i+=1
                loop
                wordval(s,i,i,dv):v=dv
                if m=1 then co+=hexb(v)
                if m=4 then co+=hexw(v)
                if m=7 then co+=hexl(v)
                do ' next data
                    a=asc(s,i)
                    if a=44 then i+=1:exit do
                    if (a<=13)or(a=39)or(a=59) then goto addcode
                    if a>37 then exit do
                    i+=1
                loop
            loop
        end if

        if wr="skip" then ' only occurs when vew=2 >> no oxygen
            capture(s,m,i,a): co=" ":goto addcode
        end if

        if wr="o2" then
            
            capture(s,m,i,a)
            if a=40 then m+=1:i-=1 ' exclude outer brackets
            co=mid$(s,m,i-m)
            if a=40 then i+=1
            goto addcode
        end if

        if a=40 then ' (
            co=" "+wr
            if brc>99 then ers="Depth limit exceeded ((()))":ert=10:goto exita
            brc+=1:scop(brc)=me:goto addcode
        end if

        if a=41 then ' )
            co=" "+wr
            me=scop(brc)
            brc-=1
            if brc<0 then ers="Too many right brackets (..))":ert=10:brc=0:goto exita
            goto addcode
        end if

        if a=46 then co="."+word(s,i):goto addcode

        if wr="exit" then co=" e9 xl":goto addcode

        if wr="repeat" then co=" e9 rl":goto addcode

        if wr="asm" then continue do ' ignore


        md=0:rg=0:rm=0:er=0:sg=0:ima=0:ic=0:sb=0
        d=len(wr)
        


'SPECIAL CASES

        m=instr(" ret in out outs outsb outsw outsd enter leave ",wd)
                '01  05 08  12   17    23    29    35    41    57
        if m>0 then
            if m=01 then
                rtf=1:k=0
                a=asclc(s,i)
                if a=&h66 then wd=word(s,i): if wd="far" then k=8:a=asc(s,i)
                if (a>13)and(a<>39)and(a<>59) then
                    wd=word(s,i)
                    wordval(s,swd,i,dv): if ert then goto exita
                    v=dv: if v>0 then co=hexb(&hc2+k)+hexw(v):goto addcode
                end if
                co=hexb(&hc3+k):goto addcode
            end if
            if m=05 then
                ' IN al or eax, nn or dx 
                b1=&he4' IN Input From Port  fixed port e4w : port number ' variable port ecw
                a=asclc(s,i)
                wd=word(s,i)
                if wd="eax" then b1+=1
                wd=word(s,i) ' swallow comma
                wd=word(s,i)
                ' no macro
                if wd="dx" then b1+=8:co=hexb(b1):goto addcode
                wordval(s,swd,i,dv): if ert then goto exita
                v=dv: co=hexb(b1)+hexb(v):goto addcode
                goto addcode
            end if
            if m=08 then
                ' OUT  nn or dx, eax or al 
                b1=&he6 ' OUT to Port  fixed port e6w : port number ' variable port eew
                wd=word(s,i)
                if wd="dx" then
                    b1+=8
                    wd=word(s,i) ' comma
                    wd=word(s,i)
                    if wd="eax" then b1+=1
                    co=hexb(b1): goto addcode
                end if
                wordval(s,swd,i,dv): if ert then goto exita
                wd=word(s,i)
                wd=word(s,i)
                if wd="eax" then b1+=1
                v=dv:co=hexb(b1)+hexb(v):goto addcode
            end if
            if m=12 then co=" 6E":goto addcode  ' OUTS  string Output to DX Port
            if m=17 then co=" 6E":goto addcode  ' OUTS  string Output to DX Port
            if (m=23)or(m=29) then co=" 6F":goto addcode
            if m=35  then ' ENTER
                wordval(s,i,i,dv):v=dv
                wd=word(s,i) ' skip comma 
                wordval(s,i,i,dv)
                co=" C8"+hexw(v)+hexb(dv): goto addcode
            end if
            if m=41 then ' LEAVE
                co=" C9": goto addcode
            end if
        end if


    b=asclc(s,i)


'INSTRUCTIONS WITHOUT OPERANDS


            if m=77 then m=01
    ' cbw   - convert byte to word
    ' cdq   - Convert Doubleword to Qword
    ' clc   - Clear Carry Flag
    ' cld   - clear direction flag
    ' cli   - Clear Direction Flag
    ' clts  - Clear Task-Switched Flag in CR0
    ' cmc   - Complement Carry Flag
    ' cpuid - CPU Identification
    ' cwd   - Convert Word to Doubleword
    ' cwde  - Convert Word to Doubleword
    ' daa   - Decimal Adjust AL after Addition 
    ' das   - Decimal Adjust AL after Subtraction 
    ' into  - Interrupt 4 on Overflow 
    ' invd - Invalidate Cache 
    ' iret / retd  Interrupt Return
    ' nop   - no operation
    ' lahf   - Load Status Flags into AH Register

    ' popa / popad    Pop All General Registers
    ' popf / popfd    Pop Stack into FLAGS or EFLAGS Register
    ' pusha / pushad  Push All General Registers
    ' pushf / pushd   Push Flags Register onto the Stack
    ' rdmsr   Read from Model-Specific Register
    ' rdpmc   Read Performance Monitoring Counters
    ' rdtsc   Read Time-Stamp Counter 
    ' rsm     Resume from System Management Mode
    ' UD2  Undefined instruction 0000 FFFF : 0000 1011

    ' sahf   - Store AH into Flags 
    ' sec     Set Carry Flag
    ' std     Set Direction Flag 
    ' sti     Set Interrupt Flag
    ' wait    Wait
    ' wbinvd  Writeback and Invalidate Data Cache
    ' wrmsr   Write to Model-Specific Register
    ' xlat    Table Look-up Translation            '
    ' stc     Set carry flag          '

    ' LOCK  Assert LOCK# Signal Prefix 1111 0000
    ' LEAVE  High Level Procedure Exit 1100 1001
    ' HLT  Halt 1111 0100
    ' AAA  ASCII Adjust after Addition 0011 0111
    ' AAD  ASCII Adjust AX before Division 
    ' AAM  ASCII Adjust AX after Multiply 
    ' AAS  ASCII Adjust AL after Subtraction 
    ' SYSENTER
    ' SYSEXIT
    ' UD2 Undefined instruction


'RELATIVE IMMEDIATE JUMPS AND CALLS

        m=0: if (a=&h63)or(a=&h6a) then m=instr ( _
        " call jmp jz jnz jl jge jle jg jb jae jbe ja jo jno js jns jpe jpo ",wd)
        '01   06  10 13  17 20  24  28 31 34  38  42 45 48  52 55  59  63  67

        if m=0 then goto Group_F

        pn=1:ws=0:ima=0:k=0
        wd=word(s,i)

        if m=1 then
            'call
            b1=&hff:bs=&he8:c=2:lw=1
            if wd="far" then
                c=3:bs=&h9a:k=1:wd=word(s,i)
            end if
            goto jumpmode
        end if

        if m=6 then
            'jmp
            b1=&hff:bs=&he9:c=4:lw=0
            if wd="far" then
                c=5:bs=&hea:k=1:wd=word(s,i)
            end if
            goto jumpmode


            jumpmode:
            if wd="[" then i=swd:goto mos
            v=regid(wd,wk)
            if v<0 then v=sregid(wd,wk)
            if v>=0 then i=swd:goto mos
            wordval(s,swd,i,dv)
            if (dv>0)or(asc(s,swd)=48) then
                ' immediate
                co=hexb(bs)+hexl(dv)
                if k=1 then
                    ' far direct absolute
                    i+=1:wordval(s,i,i,dv) ' skip colon
                    co+=hexw(dv)
                end if
                goto addcode
            end if
            wd=jword(s,swd,i,lw) ' long short
            if lw=0 then co=" EB"+wd:goto addcode ' short relative jump
            co=hexb(bs)+wd:goto addcode ' long relative jump
        end if


        ' Conditional jumps
        v=regid(wd,nn)
        if (v>=0)or(wd="[") then ers="must be a label":ert=13:goto exita
        v=-1
        do
        if m=10 then v=04:exit do ' jz je
        if m=13 then v=05:exit do ' jnz
        if m=17 then v=12:exit do ' jl
        if m=20 then v=13:exit do ' jge
        if m=24 then v=14:exit do ' jle
        if m=28 then v=15:exit do ' jg
        if m=31 then v=02:exit do ' jb  jc
        if m=34 then v=03:exit do ' jae jnc
        if m=38 then v=06:exit do ' jbe
        if m=42 then v=07:exit do ' ja
        if m=45 then v=00:exit do ' jo
        if m=48 then v=01:exit do ' jno
        if m=52 then v=08:exit do ' js
        if m=55 then v=09:exit do ' jns
        if m=59 then v=10:exit do ' jpe
        if m=63 then v=11:exit do ' jpo
        exit do
        loop

        if v>=0 then
            lw=0:wd=jword(s,swd,i,lw)
            if lw then co=" 0F"+hexb(&h80+v)+wd:goto addcode
            co=hexb(&h70+v)+wd:goto addcode
        end if

        axdi=-1

Group_F:

        if a<>&h66 then goto Group_M

        qt=4
        itf=0
        if wr="fild"  then itf=5 ' 64 bit possible
        if wr="fistp" then itf=7 ' 64 bit possible
        'FI INTEGER
        if instr(" fild fist fiadd fisub fimul fidiv fisubr fidivr fistp fimulp fidivp fidivrp ficom ficomp ",wd) then
            qt=2: wr="f"+mid$(wr,3)
        end if
        ppf=0:pp=0 'POP
        if instr(" fstp faddp fsubp fsubrp fmulp fdivp fdivrp fcomip fucomip fcomp "," "+wr) then
            if right$(wr,1)="p" then ppf=1: wr=left$(wr,len(wr)-1)
        end if
        wd=" "+wr+" "
        m=instr(" fst fld fadd fsub fmul fdiv fsubr fdivr fcomi fucomi fcom ",wd)
                '01  05  09   14   19   24   29    35    41    47     54
        if m>0 then 
            flt=1:pn=1:et=-1:d=0
            if m=01 then
                if (ppf>0)and(qt=4) then et=7  ' FST  Store Real
                b1=&hd9:bs=&hdd:c=2:d=-2:pp=&hdd:cp=3
                if ppf>0 then ppf=0:c+=1 ' fstp fistp
                goto fcode
            end if
            if m=05 then
                if qt=4 then et=5
                b1=&hd9:bs=&hd9:c=0:d=-3:goto fcode ' FLD  Load Real
            end if
            if m=09 then b1=&hd8:bs=&hd8:c=0:pp=&hde:cp=0:goto fcode ' FADD   Add
            if m=14 then b1=&hd8:bs=&hd8:c=4:pp=&hde:cp=5:goto fcode ' FSUBP  Subtract and Pop 
            if m=19 then b1=&hd8:bs=&hd8:c=1:pp=&hde:cp=1:goto fcode ' FMUL   Multiply 
            if m=24 then b1=&hd8:bs=&hd8:c=6:pp=&hde:cp=7:goto fcode ' FDIV   Divide 
            if m=29 then b1=&hd8:bs=&hd8:c=5:pp=&hde:cp=4:goto fcode ' FSUBR  Reverse Subtract 
            if m=35 then b1=&hd8:bs=&hd8:c=7:pp=&hde:cp=6:goto fcode ' FDIVR  Reverse Divide 
            if m=41 then b1=-1:  bs=&hdb:c=6:pp=&hdf:cp=6:goto fcode ' FCOMI  Compare Real and Set EFLAGS db:c-r=6 st?
            if m=47 then b1=-1:  bs=&hdb:c=5:pp=&hdf:cp=5:goto fcode ' FUCOMI  Compare Real unordered and Set EFLAGS db:c-r=6 st?
            if m=54 then b1=&hd8:bs=&hd8:c=2:pp=&hd8:cp=3:goto fcode ' FCOM   Compare Real
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
        end if

        m=instr(" fxch fbld fbstp ffree fldcw fldenv fstcw fstenv fstsw fucom fucomp frstor fsave fnsave fnstcw fnstenv fnstsw fisttp ",wd)
                '01   06   11    17    23    29     36    42     49    55    61     68     75    81     88     95      103    110    117
        if m>0 then
            flt=1:pn=1:et=-1:d=0
            if m=01 then b1=-1  :bs=&hd9:c=1:goto fcode             ' FXCH    Exchange st0 and st? d9:c 1 st? 
            if m=06 then b1=&hdf:bs=-1:et=0:c=4:goto fcode          ' FBLD    Load Binary Coded Decimal df:md-4-rm
            if m=11 then b1=&hdf:bs=-1:et=0:c=6:goto fcode          ' FBSTP   Store Binary Coded Decimal and Pop df:md-6-rm
            if m=17 then b1=-1  :bs=&hdd   :c=0:goto fcode          ' FFREE   Free st? Register dd:c 0 st? 
            if m=23 then b1=&hd9:bs=-1:qt=1:c=5:goto fcode          ' FLDCW   Load Control Word d9:md-5-rm
            if m=29 then b1=&hd9:bs=-1:qt=1:c=4:goto fcode          ' FLDENV  Load FPU Environment d9:md-4-rm
            if m=36 then b0=&h9b:b1=&hd9:bs=-1:qt=1:c=7:goto fcode  ' FSTCW   Store Control Word d9:md-7-rm
            if m=42 then b0=&h9b:b1=&hd9:bs=-1:qt=1:c=6:goto fcode  ' FSTENV  Store FPU Environment d9:md-6-rm
            if m=49 then b0=&h9b:b1=&hdd:bs=-1:qt=1:c=7:goto feax   ' FSTSW   Store Status Word into Memory dd:md-7-rm ' ax: df e0
            if m=55 then b1=-1  :bs=&hdd   :c=4:goto fcode          ' FUCOM   Unordered Compare Real dd:e 0 st?
            if m=61 then b1=-1  :bs=&hdd   :c=5:goto fcode          ' FUCOMP  Unordered Compare Real and Pop dd:e 1 st? 
            if m=68 then b1=&hdd:bs=-1:qt=1:c=4:goto fcode          ' FRSTOR  Restore FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=75 then b0=&h9b:b1=&hdd:bs=-1:qt=1:c=6:goto fcode  ' FSAVE   Store FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=81 then b1=&hdd:bs=-1:qt=1:c=6:goto fcode          ' FNSAVE   Store FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=88 then b1=&hd9:bs=-1:qt=1:c=7:goto fcode          ' FNSTCW  Store Control Word d9:md-7-rm
            if m=95 then b1=&hd9:bs=-1:qt=1:c=6:goto fcode          ' FNSTENV  Store FPU Environment d9:md-6-rm
            if m=103 then b1=&hdd:bs=-1:qt=1:c=7:goto feax          ' FNSTSW   Store Status Word into Memory dd:md-1-rm 'df/db/dd
            if m=110 then qt=5:c=1:goto mos                         ' FISTTP   Store integer with truncation ??:md-7-rm ' ax: df e0 SSE3
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
feax:
            wd=word(s,i)
            v=regid(wd,wk)
            if v=0 then
                if b0>=0 then co=hexb(b0)
                co+=" DF E0": goto addcode
            end if
            i=swd:goto fcode
        end if

        if left$(wr,5)="fcmov" then
            wp=" "+mid$(wr,6)+" "
            m=instr(" b e be u nb ne nbe nu ",wp)' FCMOVcc  Conditional Move on EFLAG
                    '1 3 5  8 10 13 16  20
            if m>0 then
                b1=-1:d=0
                bs=&hda
                if m=01 then c=0:goto fcode  ' fcmovb   -  move if below (B) da:c-0-st?
                if m=03 then c=1:goto fcode  ' fcmove   -  move if equal (E) da:c-1-st?
                if m=05 then c=2:goto fcode  ' fcmovbe  -  move if below or equal (BE) da:c-2-st?
                if m=08 then c=3:goto fcode  ' fcmovu   -  move if unordered (U) da:c-3-st?
                bs=&hdb  ' fcmov                        
                if m=10 then c=0:goto fcode  ' fcmovnb  -  move if not below (NB) db:c-0-st?
                if m=13 then c=1:goto fcode  ' fcmovne  -  move if not equal (NE) db:c-1-st?
                if m=16 then c=2:goto fcode  ' fcmovnbe -  move if not below or equal (NBE) db:c-2-st?
                if m=20 then c=3:goto fcode  ' fcmovnu  -  move if not unordered (NU) db:c-3-st?
                ers="Internal error: Misaligned "+wd:ert=19:goto exita
            end if
        end if

        if m=0 then goto Group_F1 ' fixed instructions



fcode:
        v=-1
        a=asc(s,i)
        if (a<>&h53)and(a<>&h73)and(a<>39)and(a<>59)and(a>13) then
           if b1<0 then ers="Stack operands only st(0..7) ":ert=16:goto exita
           if ppf>0 then
               'can with ficomp
               'if m<>1 then ers="Unable to pop here ":ert=16: goto exita
               b1=pp:c=cp
           end if
           wd=word(s,i)
           goto memoperand
        end if
        if bs<0 then ers="memory operands only [..] ":ert=16:goto exita
        b1=bs
        if ppf then 
            b1=pp: c=cp
        end if
        a=asc(s,i):if (a<=13)or(a=39)or(a=59) then co=hexb(b1)+hexb(&hc0+c*8+1):goto addcode ' implicit operands
        wd=word(s,i)
        if asc(s,i)=40 then i+=1 ' ignore (
        if wd="st" then
            if qt=2 then ers="FPU Integers use memory pointers, not stack regs":ert=16: goto exita
            a=asc(s,i)
            if a=40 then i+=1:a=asc(s,i)
            wd="0" ' default
            if (a>47)and(a<58) then wd=word(s,i)
            if asc(s,i)=41 then i+=1 ' ignore )
            v=val(wd)
            if (v<0)or(v>7) then ers="Expecting range 0..7 ":ert=16:goto exita
            n=i
            w=-1
            wd=word(s,i) ' comma?
            a=asc(wd)
            if a<>44 then i=n
            if a=44 then
                w=v       
                wd=word(s,i)
                if asc(s,i)=40 then i+=1 ' ignore (
                if wd<>"st" then ers="Expecting st(..)":ert=16:goto exita
                wd=word(s,i)
                if asc(s,i)=41 then i+=1 ' ignore )
                v=val(wd)
                if (v<0)or(v>7) then ers="Expecting range 0..7 ":ert=16:goto exita
                if v>w then ' attempt storing from st(1).. to st(0)
                    if d=-2 then ers="source must be st(0) dest st(0..7)":ert=16:goto exita
                end if
            end if
            if (w>0)and(v>0) then ers="one operand must be st(0)":ert=16:goto exita
            if (w=0)and(ppf) then
                ' does not apply to fcomi etc
                ' ers=" popped operation must have dest st(1..7) not st(0)":ert=16:goto exita
            end if
            b2=&hc0+c*8+v
            if (w>v) then
                if d=-3 then ers="Destination must be st(0) ":ert=16:goto exita
                b1=b1 or 4
                'if c>1 then c=c xor 1 ' swap source,dest
                if c>1 then c=c or 1 ' swap source,dest
                b2=&hc0+c*8+w
            end if
            co=hexb(b1)+hexb(b2) 
            goto addcode
        end if
        ers="Expecting st(0..7) ":ert=16: goto exita

Group_F1: 'FPU - no operands

    ' FABS     Absolute Value d9:e1
    ' FCHS     Change Sign d9:e0
    ' FLDZ     Load +0.0 into st0 d9:ee
    ' FLD1     Load +1.0 into st0 d9:e8
    ' FLDPI    Load p into st0 d9:eb
    ' FSQRT    Square Root d9:fa
    ' FSIN     Sine d9:fe
    ' FCOS     Cosine of st0 d9:ff
    ' FSINCOS  Sine and Cosine d9:fb
    ' FPTAN    Partial Tangent d9:f2
    ' FPATAN   Partial Arctangent d9:f3

    ' FCLEX    Clear Exceptions db:e2
    ' FDECSTP  Decrement Stack-Top Pointer d9:f6
    ' FINCSTP  Increment Stack Pointer d9:f7
    ' FINIT    Initialize Floating-Point Unit db e3
    ' FNOP     No Operation d9:d0
    ' FPREM    Partial Remainder d9:f8
    ' FPREM1   Partial Remainder (IEEE) d9:f5
    ' FRNDINT  Round to Integer d9:fc
    ' FSCALE   Scale d9:fd
    ' FSTSW    Store Status Word (to ax)
    ' FTST  Test d9:e4
    ' FUCOMPP  Unordered Compare Real and Pop Twice da:e9
    ' FXAM     Examine d9:e5
    ' FXTRACT  Extract Exponent and Significand d9:f 4

    ' FCOMPP   Compare Real and Pop Twice de:c-3-1
    ' F2XM1    Compute 2ST(0)  1 d9:f0
    ' FLDL2E   Load log2(e) into st0 d9:ea
    ' FLDL2T   Load log2(10) into st0 d9:e9
    ' FLDLG2   Load log10(2) into st0 d9:ec
    ' FLDLN2   Load loge(2) into st0 d9:ed
    ' FYL2X    st1  log2(ST(0)) d9:f1
    ' FYL2XP1  st1  log2(ST(0) + 1.0) d9:f9
    ' FWAIT

Group_M:



'CPU INSTRUCTIONS WITH OPERANDS


'GENERAL ARITHMETIC AND LOGIC


m1:
        m=instr(" mov inc dec push pop add sub mul div cmp and or xor test xchg movsx movzx ",wd)
                '01  05  09  13  18  22  26  30  34  38  42   46 49  53   58   63    69    75
        if m>0 then
            ima=1
            if m=01 then
                pn=2: b1=&h88: axdi=&hb0: im=&hc6
                ic=0: ima=2: axim=&ha0
                goto mos 'mov
            end if
            if m=05 then pn=1: b1=&hfe: sb=&h40:  c=0:ima=0 :goto mos ' inc
            if m=09 then pn=1: b1=&hfe: sb=&h48:  c=1:ima=0 :goto mos ' dec
            if m=13 then pn=1: b1=&hff: sb=&h50: c=6:im=&h68: ic=0 :goto mos 'push
            if m=18 then pn=1: b1=&h8f: sb=&h58:  c=0:ima=0 :goto mos  ' pop
            if m=22 then pn=2: b1=&h00: im=&h80: ic=0: ima=1:goto mos  ' add
            if m=26 then pn=2: b1=&h28: im=&h80: ic=5: ima=1:goto mos  ' sub
            if m=38 then pn=2: b1=&h38: im=&h80: ic=7: ima=1:goto mos  ' cmp
            if m=30 then pn=1: b1=-1: axdi=&hf6:  c=4       :goto mos  ' mul
            if m=34 then pn=1: b1=-1: axdi=&hf6:  c=6:      :goto mos  ' div
            if m=42 then pn=2: b1=&h20: im=&h80: ic=4: ima=1:goto mos  ' and
            if m=46 then pn=2: b1=&h08: im=&h80: ic=1: ima=1:goto mos  ' or
            if m=49 then pn=2: b1=&h30: im=&h80: ic=6: ima=1:goto mos  ' xor
            if m=53 then pn=2: b1=&h84: im=&hf6: ic=0: ima=1:goto mos  ' test (no di)
            if m=58 then pn=2: b1=&h84:axdi=&h90:      ima=0:goto mos  ' XCHG  Exchange Register/Memory with mrm and AL/AX/EAX Register 90+reg
            if m=63 then pn=3: b0=&h0f:b1=&hbe:        ima=0:goto mos  ' MOVSX Move with Sign-Extend
            if m=69 then pn=3: b0=&h0f:b1=&hb6:        ima=0:goto mos  ' MOVZX Move with Zero-Extend
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
        end if

        m=instr(" neg not adc sbb imul idiv bound arpl bsf bsr ",wd)
                '01  05  09  13  17   22   27    33   38  42  46
        if m>0 then
            if m=01 then pn=1: b1=&hf6:          c=3:goto mos          ' neg
            if m=05 then pn=1: b1=&hf6:          c=2:goto mos          ' not
            if m=09 then pn=2: b1=&h10: im=&h80: ic=2: ima=1:goto mos  ' adc
            if m=13 then pn=2: b1=&h18: im=&h80: ic=3: ima=1:goto mos  ' sbc
            if m=17 then pn=12:b1=&h69:axdi=&hf6:c=5:im=&h69:ic=&h0:ima=1:goto mos   ' imul **** todo extra formats
            ' also extended modes 0f af mrm  mem imm to reg = 69 6b mrm dat
            if m=22 then pn=1: b1=-1  : axdi=&hf6: c=7: ima=0 :goto mos  ' idiv
            '-----------------------------------------------------------------
            if m=27 then pn=3: b1=&h62                      :goto mos  ' BOUND  Check Array Against Bounds
            if m=33 then pn=4: b1=&h63                      :goto mos  ' ARPL  Adjust RPL Field of Selector '+ws
            if m=38 then pn=3: b0=&h0f: b1=&hbc:rsf=4       :goto mos  ' BSF  Bit Scan Forward
            if m=42 then pn=3: b0=&h0f: b1=&hbd:rsf=4       :goto mos  ' BSR  Bit Scan Reverse
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
        end if



'BIT SHIFTING

        m=instr(" rcl rcr rol ror sal sar shl shr shld shrd ",wd)
                '01  05  09  13  17  21  25  29  33   38   43
        if m>0 then
            pn=13:b1=&hd0:im=&hc0::ima=8
            if m=25 then m=17
            do
            if m=01 then c=2:ic=2 :exit do ' RCL  Rotate thru Carry Left df by cl 8bit imm
            if m=05 then c=3:ic=3 :exit do ' RCR  Rotate thru Carry Right df by cl 8bit imm
            if m=09 then c=0:ic=0 :exit do ' ROL  Rotate Left  8bit imm
            if m=13 then c=1:ic=1 :exit do ' ROR  Rotate Right 8bit imm
            if m=17 then c=4:ic=4 :exit do ' SAL  Shift Left   8bit imm
            if m=21 then c=7:ic=7 :exit do ' SAR  Shift Right  8bit imm
            if m=29 then c=5:ic=5 :exit do ' SHR  Shift Right  8bit imm
            pn=11
            if m=33 then b0=&h0f:b1=&ha5:c=0:im=&ha4:ic=0 :exit do ' SHLD  Double Precision Shift Left
            if m=38 then b0=&h0f:b1=&had:c=0:im=&hac:ic=0 :exit do ' SHRD  Double Precision Shift Right
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
            loop
            goto mos
        end if




'ITERATIVES

        m=instr(" jcxz jecxz loopz loope loopnz loopne loop ",wd)
                '01   06    12    18    24     31     38   43
        if m>0 then
            pn=0:c=0:rmf=3
            do            
            if (m=01)or(m=06) then b1=&he3    :exit do ' JCXZ/JECXZ     Jump on CX/ECX Zero Address-size prefix differentiates JCXZ and JECXZ 1110 0011 : 8-bit displacement
            if (m=12)or(m=18) then b1=&he1    :exit do ' LOOPZ/LOOPE    Loop Count while Zero/Equal 1110 0001 : 8-bit displacement
            if (m=24)or(m=31) then b1=&he0    :exit do ' LOOPNZ/LOOPNE  Loop Count while not Zero/Equal 1110 0000 : 8-bit displacement
            if m=38           then b1=&he2    :exit do ' LOOP           Loop Count 1110 0010 : 8-bit displacement
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
            loop
            if asclc(s,i)=&h6c then
                if wd="long" then ers="Short jump only ":ert=15:goto exita
            end if
            if m<=6 then
                if asclc(s,i)<&h65 then ers="Expecting 'exit' repeat' or a label ":ert=17:goto exita
                wd=word(s,i)
                do
                if wd="exit" then wd="x":exit do
                if wd="repeat" then wd="r":exit do
                if len(wd) then wd="g "+wd: exit do
                exit do
                loop
                co=hexb(b1)+" "+wd:goto addcode
            end if
            if brc=0 then ers="Expecting loop to be within a block (..) ":ert=15:goto exita
            co+=hexb(b1)+" r"
            goto addcode
        end if


        v=instr(" rep repe repne ",wd)
                '01  05   10    16
        wp=wr    
        if v>0 then wp=word(s,i) ' rep something
        l=len(wp):b=asc(wp,l)
        if (b=&h62)or(b=&h64)or(b=&h77) then l-=1:wp=left$(wp,l)
        if asc(wp,l)<>&h73 then goto nost
        ws=0: if (b=&h64)or(b=&h77) then ws=1
        m=instr(" ins lods movs outs cmps stos scas "," "+wp+" ")
                '01  05   10   15   20   25   30   35
        if m>0 then
            do
            if (v=1)or(v=5) then b0=&hf3
            if v=10 then b0=&hf2
            if m=01 then b1=&h6c  :exit do ' REP INS   Input String     f3 : 6cw
            if m=05 then b1=&hac  :exit do ' REP LODS  Load String      f3 : acw
            if m=10 then b1=&ha4  :exit do ' REP MOVS  Move String      f3 : a4w
            if m=15 then b1=&h6e  :exit do ' REP OUTS  Output String    f3 : 6ew
            if m=20 then b1=&ha6  :exit do ' REP CMPS  Compare String   f3 : a6w
            if m=25 then b1=&haa  :exit do ' REP STOS  Store String     f3 : aaw
            if m=30 then b1=&hae  :exit do ' REP SCAS  Scan String      f3 : aew
            ers="expecting ins lods movs outs stos scas etc ":ert=15: goto exita
            loop
            b1+=ws
            if b0>=0 then co=hexb(b0)
            co+=hexb(b1)
            goto addcode
        end if
nost:

        if wr="int" then
            wd=word(s,i)
            v=val(wd)
            if v=3 then co=" CC": goto addcode      ' INT 3
            co=" CD"+hexb(v): goto addcode ' INT imm8
        end if






'ima 1 8 or 16 bit data
'    8 8  bit data only


    ' BT   Bit Test 
    ' BTC  Bit Test and Complement
    ' BTR  Bit Test and Reset
    ' BTS  Bit Test and Set
    ' XADD  Exchange and Add 0f c0w mrm

    ' SGDT  Store Global Descriptor Table Register 0f:01:m0m
    ' SIDT  Store Interrupt Descriptor Table Register of:01:m1m
    ' SLDT  Store Local Descriptor Table Register mrm
    ' SMSW  Store Machine Status Word mxm
    ' STR   Store Task Register mxm
    ' VERR  Verify a Segment for Reading m4m
    ' VERW  Verify a Segment for Writing m5m
    ' CMPXCHG  Compare and Exchange
    ' CMPXCHG8B  Compare and Exchange 8 Bytes


    ' LDS   Load Pointer to DS
    ' LEA   Load Effective Address
    ' LES   Load Pointer to ES
    ' LAR   Load Access Rights Byte
    ' LFS   Load Pointer to FS
    ' LGDT  Load Global Descriptor Table Register
    ' LIDT  Load Global Descriptor Table Register
    ' LGS   Load Pointer to GS mrm
    ' LSL   Load Segment Limit
    ' LSS   Load Pointer to SS
    ' LTR   Load Task Register
    ' LLDT  Load Local Descriptor Table Register
    ' LMSW  Load Machine Status Word

' SET conditional

        m=instr(" cmovz cmovnz cmovl cmovge cmovle cmovg cmovb cmovae cmovbe cmova cmovo cmovno cmovs cmovns cmovpe cmovpo ",wd)
                '01   07      14    20     27     34    40    46     53     60    66    72     79    85     92     99     106
        if m>0 then
            ' cmovcc Byte Set on Condition '  register 0f:40+tttn : m0m
            ' 8 bit regs
            pn=2:b0=&h0f:b1=&h40:flt=4
            v=-1
            do
            if m=01 then v=04:exit do ' cmovz
            if m=07 then v=05:exit do ' cmovnz
            if m=14 then v=12:exit do ' cmovl
            if m=20 then v=13:exit do ' cmovge
            if m=27 then v=14:exit do ' cmovle
            if m=34 then v=15:exit do ' cmovg
            if m=40 then v=02:exit do ' cmovb
            if m=46 then v=03:exit do ' cmovae
            if m=53 then v=06:exit do ' cmovbe
            if m=60 then v=07:exit do ' cmova
            if m=66 then v=00:exit do ' cmovo
            if m=73 then v=01:exit do ' cmovno
            if m=79 then v=08:exit do ' cmovs
            if m=85 then v=09:exit do ' cmovns
            if m=92 then v=10:exit do ' cmovpe
            if m=99 then v=11:exit do ' cmovpo
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
            loop
            b1+=v
            goto mos
        end if

' SET conditional

        m=instr(" setz setnz setl setge setle setg setb setae setbe seta seto setno sets setns setpe setpo ",wd)
                '01   06    12   17    23    29   34   39    45    51   56   61    67   72    78    84    90
        if m>0 then
            ' SETcc Byte Set on Condition '  register 0f:90+tttn : m0m
            ' 8 bit regs
            pn=1:b0=&h0f:b1=&h90
            v=-1
            c=0
            do
            if m=01 then v=04:exit do ' setz
            if m=06 then v=05:exit do ' setnz
            if m=12 then v=12:exit do ' setl
            if m=17 then v=13:exit do ' setge
            if m=23 then v=14:exit do ' setle
            if m=29 then v=15:exit do ' setg
            if m=34 then v=02:exit do ' setb
            if m=39 then v=03:exit do ' setae
            if m=45 then v=06:exit do ' setbe
            if m=51 then v=07:exit do ' seta
            if m=56 then v=00:exit do ' seto
            if m=61 then v=01:exit do ' setno
            if m=67 then v=08:exit do ' sets
            if m=72 then v=09:exit do ' setns
            if m=78 then v=10:exit do ' setpe jp
            if m=84 then v=11:exit do ' setpo jnp
            ers="Internal error: Misaligned "+wd:ert=19:goto exita
            loop
            b1+=v
            goto mos
        end if



'Prefix Bytes
'  address size 0110 0111        '
'  LOCK 1111 0000                '
'  operand size 0110 0110        ' word
'  CS segment override 0010 1110 ' seg CS
'  DS segment override 0011 1110 ' seg ds
'  ES segment override 0010 0110 ' seg es
'  FS segment override 0110 0100 ' seg fs
'  GS segment override 0110 0101 ' seg gs
'  SS segment override           '



'=============
'MMX ENCODINGS
'=============




        if asc(wr)=&h70 then
            gg=0
            v=len(wr)
            wp=left$(wr,v-1)
            m=instr(" padd padds paddus pcmpeq pcmpgt psll psra psrl psub psubs psubus punpckhb punpckhw punpckhd punpcklb punpcklw punpckld "," "+wp)
            if m>0 then
                a=asc(wr,v)
                k=-1
                if a=&h62 then k=0 ' b
                if a=&h77 then k=1 ' w
                if a=&h64 then k=2 ' d
                if a=&h71 then k=3 ' q ' psllq
                if k>=0 then
                    gg=k
                    wr=left$(wr,v-1)
                    wd=" "+wr+" "
                end if
            end if
        end if 


        if d>3 then m=instr(" emms movd movq packssdw packsswb packuswb padd padds paddus pand pandn ",wd)
                            '01   06   11   16       25       34       43   48    54     61   66    72
        if m>0 then
            pn=3
            b0=&h0f
            im=-1
            ' d=0 1 2 3
            ' b2= md-mmx-rm
            ' di +&h10 to mem
            ' immediate opts
            do
            if m=01 then b1=&h77 :exit do ' EMMS      - Empty MMX state 
            if m=06 then b1=&h6e:pn=2:exit do ' MOVD      - Move doubleword:  mem to mx 0f:6e: mem from mx 0f:7e
            if m=11 then b1=&h6f:pn=2:exit do ' MOVQ      - Move quadword: mem to mx 0f:6f: mem from mx 0f:7f
            if m=16 then b1=&h6b :exit do ' PACKSSDW1 - Pack dword to word data (signed with saturation) memory to mx 0f:6b
            if m=25 then b1=&h63 :exit do ' PACKSSWB1 - Pack word to byte data (signed with saturation):   memory to mx 0f:63
            if m=34 then b1=&h67 :exit do ' PACKUSWB1 - Pack word to byte data (unsigned with saturation):   memory to mx 0f:67
            if m=43 then b1=&hfc :exit do ' PADD      - Add with wrap-around:   memory to mx 0f: fc+gg
            if m=48 then b1=&hec :exit do ' PADDS     - Add signed with saturation: memory to mx 0f: ec+gg
            if m=54 then b1=&hdc :exit do ' PADDUS    - Add unsigned with saturation: memory to mx 0f: dc+gg
            if m=61 then b1=&hdb :exit do ' PAND      - Bitwise And:   memory to mx 0f:db
            if m=66 then b1=&hdf :exit do ' PANDN     - Bitwise AndNot: mmxreg2 to mmxreg1 0f:bf:c-mx1-mx2:   memory to mx 0f:df
            ers="Internal error: Misaligned MMX list1"+wd:ert=19:goto exita
            loop
            v=b1:b1+=gg:gg=0
            if v=&h77 then co=" 0F"+hexb(b1): goto addcode ' check for junk
            flt=2:goto mos
        end if


        m=instr(" pcmpeq pcmpgt pmaddwd pmulhw pmullw por psll psra psrl psub psubs psubus punpckhb punpckhw punpckhd punpcklb punpcklw punpckld pmulhuw pxor ",wd)
                '01     08     15      23     30     37  41   46   51   56   61    67     74       83      92        101     110       119      128     136  141
        if m>0 then
            pn=3
            b0=&h0f
            im=-1
            ' b2= md-mmx-rm
            do
            if m=01  then b1=&h74         :exit do ' PCMPEQ  - Packed compare for equality: mx with memory 0f:74+gg
            if m=08  then b1=&h64         :exit do ' PCMPGT  - Packed compare greater (signed):   mx with memory 0f:64+gg
            if m=15  then b1=&hf5         :exit do ' PMADDWD - Packed multiply add: memory to mx 0f:f5
            if m=23  then b1=&he5         :exit do ' PMULHW  - Packed multiplication: memory to mx 0f:e5
            if m=30  then b1=&hd5         :exit do ' PMULLW  - Packed multiplication: memory to mx 0f:d5
            if m=37  then b1=&heb         :exit do ' POR     - Bitwise Or:   memory to mx 0f:eb
            if m=136 then b1=&hef         :exit do ' PXOR    - Bitwise Or:   memory to mx 0f:ef
            if m=41  then b1=&hf0:im=&h70:ic=6:exit do ' PSLL2   - Packed shift left logical: mx by memory 0f:f0+gg:md-mx-rm:  mx by immediate 0f:70+gg: c-6-mx: imm8 data
            if m=46  then b1=&he0:im=&h70:ic=4:exit do ' PSRA2   - Packed shift right arithmetic: mx by memory 0f:e0+gg:md-mx-rm:  mx by immediate 0f:70+gg: c-4-mx: imm8 data
            if m=51  then b1=&hd0:im=&h70:ic=2:exit do ' PSRL2   - Packed shift right logical: mx by memory 0f:d0+gg:md-mx-rm :   mx by immediate 0f:70+gg: c-2-mx: imm8 data
            if m=56  then b1=&hf8         :exit do ' PSUB    - Subtract with wraparound: memory from mx 0f:f8+gg
            if m=61  then b1=&he8         :exit do ' PSUBS   - Subtract signed with saturation: memory from mx 0f:e8+gg:md-mx-rm
            if m=67  then b1=&hd8         :exit do ' PSUBUS  - Subtract unsigned with saturation: memory from mx 0f:d8+gg
            if (m=74)or(m=83)or(m=92) then b1=&h67 :exit do ' PUNPCKH - Unpack high data to next larger type: memory to mx 0f:68+gg
            if (m=101)or(m=110)or(m=119) then b1=&h5F :exit do ' PUNPCKH - Unpack high data to next larger type: memory to mx 0f:68+gg
            if m=128 then b1=&he4                     :exit do ' PMULHUW     - Packed Multiply High Unsigned : mm to mm 0f:e4:c-mm1-mm2 : mem to mm 0f:e4:md-mm-rm
            ers="Internal error: Misaligned MMX list2"+wd:ert=19:goto exita
            loop
            if im>=0 then im+=gg:ima=8 ' + 8bit data
            flt=2:b1+=gg:gg=0:goto mos
        end if


'===============
' SIMD ENCODINGS
'===============

        c=0

'SSE2


    '    0f 58 ADDPS        - Packed Single-FP Add : xm to xm   0f:58:c-mx1-xm2 : mem to xm 0f:58:md-xm-rm
    ' f3 0f 58 ADDSS        - Scalar Single- FP Add xm to xm f3:0f:58:c xm1 xm2 :  mem to xm f3:0f:58:md-xm-rm
    '    0f 55 ANDNPS       - Bit-wise Logical And Not for Single-FP :  xm to xm 0f:55:c-mx1-xm2 : mem to xm 0f:55:md-xm-rm
    '    0f 54 ANDPS        - Bit-wise Logical And for Single-FP :  xm to xm 0f:54:c-mx1-xm2 :   mem to xm 0f:54:md-xm-rm
    '    0f c2 CMPPS        - Packed Single-FP Compare : xm to xmmreg, imm8 0f:c2:c-mx1-xm2: imm8 : mem to xmmreg, imm8 0f:c2:md-xm-rm: imm8
    ' f3 0f c2 CMPSS        - Scalar Single-FP Compare : xm to xmmreg, imm8 f3:0f:c2:c xm1 xm2: imm8 :   mem to xmmreg, imm8 f3:0f:c2:md-xm-rm: imm8
    '    0f 2f COMISS       - Scalar Ordered Single-FP compare and set EFLAGS :   xm to xm 0f:2f:c-mx1-xm2 : mem to xm 0f:2f:md-xm-rm
    '    0f 2a CVTPI2PS     - Packed signed INT32 to Packed Single-FP conversion :   mm to xm 0f:2a:c mx1 mmreg1 :  mem to xm 0f:2a:md-xm-rm
    '    0f 2d CVTPS2PI     - Packed Single-FP to Packed INT32 conversion :   xm to mm 0f:2d:c-mm1-xm1 : mem to mm 0f:2d:md-mm-rm
    ' f3 0f 2a CVTSI2SS     - Scalar signed INT32 to Single- FP conversion :   r32 to mx1 f3:0f:2a:c xm r32 :   mem to xm f3:0f:2a:md-xm-rm
    ' f3 0d 2d CVTSS2SI     - Scalar Single-FP to signed INT32 conversion :   xm to r32 f3:0f:2d:c r32 xmmreg : mem to r32 f3:0f:2d:md-r32-rm
    '    0f 2c CVTTPS2PI    - Packed Single-FP to Packed INT32 Conversion (truncate) : xm to mm 0f:2c:c-mm1-xm1 : mem to mm 0f:2c:md-mm-rm
    ' f3 0f 2c CVTTSS2SI    - Scalar Single-FP to signed INT32 conversion (truncate) : xm to r32 f3:0f:2c:c-r32-xm1 : mem to r32 f3:0f:2c:md-r32-rm
    '    0f 5e DIVPS        - Packed Single-FP Divide : xm to xm 0f:5e:c-mx1-xm2 : mem to xm 0f:5e:md-xm-rm
    ' f3 0f 5e DIVSS        - Scalar Single-FP :   Divide f3:0f:5e:c-xm1-xm2 : xm to xm : mem to xm f3:0f:5e:md-xm-rm
    '    0f ae 40 FXRSTOR   - Restore FP/MMX and Streaming SIMD Extensions state : 0f:ae:40+m512
    '    0f ae 00 FXSAVE    - Store FP/MMX and Streaming SIMD Extensions state : 0f:ae:00+m512 
    '    0f ae 80 LDMXCSR   - Load Streaming SIMD Extensions Technology Control/Status Register : m32 to MXCSR 0f:ae:80+m32

    '    0f 5f MAXPS        - Packed Single-FP Maximum :   xm to xm 0f:5f:c-mx1-xm2 : mem to xm 0f:5f:md-xm-rm
    ' f3 0f 5f MAXSS        - Scalar Single-FP Maximum : xm to xm f3:0f:5f:c-xm1-xm2 : mem to xm f3:0f:5f:md-xm-rm
    '    0f 5d MINPS        - Packed Single- FP Minimum : xm to xm 0f:5d:c-mx1-xm2 : mem to xm 0f:5d:md-xm-rm
    ' f3 0f 5d MINSS        - Scalar Single-FP Minimum : xm to xm f3:0f:5d:c-xm1-xm2 : mem to xm f3:0f:5d:md-xm-rm
    '    0f 28 MOVAPS       - Move Aligned Four Packed Single-FP : mx2 to mx1 0f:28:c mx2 xm1 : mem to mx1 0f:28:md-xm-rm : mx1 to mx2 0f:29:c-mx1-xm2 : mx1 to mem 0f:29:md-xm-rm
    '    0f 90 MOVHLPS      - Move High to Low Packed Single-FP : xm to xm 0f:90:c-mx1-xm2
    '    0f 16 MOVHPS       - Move High Packed Single-FP : mem to xm 0f:16:md-xm-rm : xm to mem 0f:17:md-xm-rm
    '    0f 16 MOVLHPS      - Move Low to High Packed Single-FP : xm to xm 0f:16:c-mx1-xm2
    '    0f 90 MOVLPS       - Move Low Packed Single-FP : mem to xm 0f:90:md-xm-rm : xm to mem 0f:91:md-xm-rm
    '    0f 50 MOVMSKPS     - Move Mask To Integer : xm to r32 0f:50:c r32 xmmreg
    ' f3 0f 80 MOVSS        - Move Scalar Single-FP : mx2 to mx1 f3:0f:80:c-xm2-xm1 : mem to mx1 f3:0f:80:md-xm-rm : mx1 to mx2 f3:0f:80:c-xm1-xm2 : mx1 to mem f3:0f:80:md-xm-rm
    '    0f 80 MOVUPS       - Move Unaligned Four Packed  single-FP : mx2 to mx1 0f:80:c mx2 xm1 :   mem to mx1 0f:80:md-xm-rm : mx1 to mx2 0f:81:c-mx1-xm2 : mx1 to mem 0f:81:md-xm-rm
    '    0f 59 MULPS        - Packed Single-FP Multiply : xm to xm 0f:59:c-mx1-xm2 : mem to xm 0f:59:md-xm-rm
    ' f3 0f 59 MULSS        - Scalar Single-FP Multiply : xm to xm f3:0f:59:c-xm1-xm2 : mem to xm f3:0f:59:md-xm-rm
    '    0f f7 MASKMOVQ     - Byte Mask Write :   mm to mm 0f:f7:c-mm1-mm2
    '    0f 2b MOVNTPS      - Move Aligned Four Packed Single-FP Non Temporal :   xm to mem 0f:2b:md-xm-rm
    '    0f e7 MOVNTQ       - Move 64 Bits Non Temporal :   mm to mem 0f:e7:md-mm-rm

    '    0f 56 ORPS:        - Bit-wise Logical OR for Single-FP Data : xm to xm 0f:56:c-mx1-xm2 : mem to xm 0f:56:md-xm-rm
    '    0f 53 RCPPS        - Packed Single-FP Reciprocal : xm to xm 0f:53:c-mx1-xm2 : mem to xm 0f:53:md-xm-rm
    ' f3 0f 53 RCPSS        - Scalar Single-FP Reciprocal : xm to xm f3:0f:53:c-xm1-xm2 : mem to xm f3:0f:53:md-xm-rm
    '    0f 52 RSQRTPS      - Packed Single-FP Square Root Reciprocal : xm to xm 0f:52:c-mx1-xm2 : mem to xm 0f:52 mode-xm-rm
    ' f3 0f 52 RSQRTSS      - Scalar Single-FP Square Root Reciprocal : xm to xm f3:0f:52:c-xm1-xm2 : mem to xm f3:0f:52:md-xm-rm
    '    0f c6 SHUFPS       - Shuffle Single-FP : xm to xmmreg, imm8 0f:c6:c-mx1-xm2:imm8 : mem to xmmreg, imm8 0f:c6:md-xm-rm:imm8
    '    0f 51 SQRTPS       - Packed Single-FP Square Root : xm to xm 0f:51:c-mx1-xm2 : mem to xm 0f:51:md-xm-rm
    ' f3 0f 51 SQRTSS       - Scalar Single-FP Square Root : xm to xm f3:0f:51:c-xm1-xm2 : mem to xm f3:0f:51:md-xm-rm
    '    0f ae STMXCSR      - Store Streaming SIMD Extensions Technology Control/Status Register : MXCSR to mem 0f:ae:c m32
    '    0f 5c SUBPS        - Packed Single-FP Subtract : xm to xm 0f:5c:c-mx1-xm2 : mem to xm 0f:5c:md-xm-rm
    ' f3 0f 5c SUBSS        - Scalar Single-FP Subtract : xm to xm f3:0f:5c:c-xm1-xm2 : mem to xm f3:0f:5c:md-xm-rm
    '    0f ae f8 SFENCE    - Store Fence 0f:ae:f8 
    '    0f 2e UCOMISS      - Unordered Scalar Single-FP compare and set EFLAGS : xm to xm 0f:2e:c-mx1-xm2 : mem to xm 0f:2e:md-xm-rm
    '    0f a1 UNPCKHPS     - Unpack : High Packed Sing  le-FP Data : xm to xm 0f:a1:c-mx1-xm2 : mem to xm 0f:a1:md-xm-rm
    '    0f a0 UNPCKLPS     - Unpack Low Packed Single-FP Data : xm to xm 0f:a0:c-mx1-xm2 : mem to xm 0f:a0:md-xm-rm
    '    0f 57 XORPS        - Bitwise Logical Xor for Single-FP Data : xm to xm 0f:57:c-mx1-xm2 : mem to xm 0f:57:md-xm-rm

    ' 0f e0 PAVGB           - Packed Average : mm to mm 0f:e0:c-mm1-mm2 : 0f:e3:c-mm1-mm2 : mem to mm 0f:e0:md-mm-rm : 0f:e3:md-mm-rm
    ' 0f e3 PAVGW           - Packed Average : mm to mm 0f:e0:c-mm1-mm2 : 0f:e3:c-mm1-mm2 : mem to mm 0f:e0:md-mm-rm : 0f:e3:md-mm-rm
    ' 0f c5 PEXTRW          - Extract Word :   mm to reg32, imm8 0f:c5:c mm r32: imm8
    ' 0f c4 PINSRW          - Insert Word : reg32 to mmreg, imm8 0f:c4:c r32 mmreg1: imm8 : m16 to mmreg, imm8 0f:c4:md-mm-rm: imm8
    ' 0f ee PMAXSW          - Packed Signed Integer Word Maximum : mm to mm 0f:ee:c-mm1-mm2 : mem to mm 0f:ee:md-mm-rm
    ' 0f de PMAXUB          - Packed Unsigned Integer Byte Maximum : mm to mm 0f:de:c-mm1-mm2 : mem to mm 0f:de:md-mm-rm
    ' 0f ea PMINSW          - Packed Signed Integer Word Minimum : mm to mm 0f:ea:c-mm1-mm2 :  mem to mm 0f:ea:md-mm-rm
    ' 0f da PMINUB          - Packed Unsigned Integer Byte Minimum Y : mm to mm 0f:da:c-mm1-mm2 : mem to mm 0f:da:md-mm-rm
    ' 0f d7 PMOVMSKB        - Move Byte Mask To Integer O : mm to reg32 0f:d7:c-mm1-r32 : 
    ' 0f f6 PSADBW          - Packed Sum of Absolute Differences I O : mm to mm 0f:f6:c-mm1-mm2 : mem to mm 0f:f6:md-mm-rm
    ' 0f 70 PSHUFW          - Packed Shuffle Word : mm to mmreg, imm8 0f:70:c-mm1-mm2: imm8 :   mem to mmreg, imm8 0f:70:c:md-mm-rm: imm8


'SSE2 extended

    ' 66 0f 10 MOVUPD   - Move Unaligned 
    ' 66 0f 12  MOVLPD   - Move  
    ' 66 0f 16 MOVHPD   - Move 
    ' 66 0f 14 UNPCKLPD   -
    ' 66 0f 15 UNPCKHPD   -  


'SSE3



    ' 66,0F,D0,/r ADDSUBPD xmm1, xmm2/m128 Add /Sub packed DP FP numbers from XMM2/Mem to XMM1. Y Y Y Y Y 
    ' F2,0F,D0,/r ADDSUBPS xmm1, xmm2/m128 Add /Sub packed SP FP numbers from XMM2/Mem to XMM1. Y Y Y Y Y
    ' DF /1 FISTTP m16int Store ST in int16 (chop) and pop. Y Y DB /1 FISTTP m32int Store ST in int32 (chop) and pop. Y Y
    ' 66,0F,7C,/r HADDPD xmm1, xmm2/m128 Add horizontally packed DP FP numbers XMM2/Mem to XMM1. Y Y Y Y Y
    ' F2,0F,7C,/r HADDPS xmm1,xmm2/m128 Add horizontally packed SP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' 66,0F,7D,/r HSUBPD xmm1, xmm2/m128 Sub horizontally packed DP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' F2,0F,7D,/r HSUBPS xmm1,xmm2/m128 Sub horizontally packed SP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' F2,0F,F0,/r LDDQU xmm, m128 Load unaligned integer 128-bit. 0F,01,C8 MONITOR eax, ecx, edx Set up a linear address range to be monitored by hardware.
    ' F2,0F,12,/r MOVDDUP xmm1, xmm2/m64 Move 64 bits representing one DP data from XMM2/Mem to XMM1 and duplicate.
    ' F3,0F,16,/r MOVSHDUP xmm1, xmm2/m128 Move 128 bits representing 4 SP data from XMM2/Mem to XMM1 and duplicate high.
    ' F3,0F,12,/r MOVSLDUP xmm1,xmm2/m128 Move 128 bits representing 4 SP data from XMM2/Mem to XMM1 and duplicate low.
    ' 0F,01,C9 MWAIT eax, ecx Wait until write-back store performed within the range specified by the instruction MONITOR.


'SSE4


    ' 66 0F 3A 0D BLENDPD xmm1, xmm2/m128, imm8 Blend Packed Double Precision Floating-Point Values
    ' 66 0F 3A 0C BLENDPS xmm1, xmm2/m128, imm8 Blend Packed Single Precision Floating-Point Values
    ' 66 0F 38 15 BLENDVPD xmm1, xmm2/m128, <XMM0> Variable Blend Packed Double Precsion Floating-Point Values
    ' 66 0F 38 14 BLENDVPS xmm1, xmm2/m128, <XMM0> Variable Blend Packed Single Precision Floating-Point Values
    ' 66 0F 3A 41 DPPD xmm1, xmm2/m128 imm8 Dot Product of Packed Double Precision Floating Point Values
    ' 66 0F 3A 40 DPPS xmm1, xmm2/m128. imm8 Dot Product of Packed Single Precision Floating Point Values
    ' 66 0F 3A 17 EXTRACTPS r/m32, xmm imm8 Extract Packed Single Precision Floating-Point Value
    ' 66 0F 3A 21 INSERTPS xmm1, xmm2/m32, imm8 Insert Packed Single Precision Floating-Point Value
    ' 66 0F 38 2A MOVNTDQA xmm, m128 Load Double Quadword Non-Temporal Aligned Hint
    ' 66 0F 3A 42 MPSADBW xmm1, xmm2/m128, imm8 Compute Multiple Packed Sums of Absolute Difference
    ' 66 0F 38 2B PACKUSDW xmm1,xmm2/m128 Pack with Unsigned Saturation
    ' 66 0F 38 10 PBLENDVB xmm1,xmm2/m128, <XMM0> Variable Blend Packed Bytes
    ' 66 0F 3A 0E PBLENDW xmm1, xmm2/m128, imm8 Blend Packed Words
    ' 66 0F 38 29 PCMPEQQ xmm1, xmm2/m128 Compare Packed Qword Data for Equal
    ' 66 0F 3A 14 PEXTRB r32/m8, xmm, imm8 Extract Byte
    ' 66 0F 3A 16 PEXTRD r/m32, xmm, imm8 Extract Dword
    ' 66 REX.w 0F 3A 16 PEXTRQ r/m64, xmm, imm8 Extract Qword
    ' 66 0F 3A 15 PEXTRW r/m16, xmm, imm8 Extract Word ' ? ALTERNATIVE CODING
    ' 66 0F 38 41 PHMINPOSUW xmm1, xmm2/m128 Packed Horizontal Word Minimum
    ' 66 0F 3A 20 PINSRB xmm1, r32/m8, imm8 Insert Byte
    ' 66 0F 3A 22 PINSRD xmm1, r/m32, imm8 Insert Dword
    ' 66 REX.w 0F 3A 22 PINSRQ xmm1, r/m64, imm8 Insert Qword
    ' 66 0F 38 3C PMAXSB xmm1, xmm2/m128 Maximum of Packed Signed Byte Integers
    ' 66 0F 38 3D PMAXSD xmm1, xmm2/m128 Maximum of Packed Signed Dword Integers
    ' 66 0F 38 3F PMAXUD xmm1, xmm2/m128 Maximum of Packed Unsigned Dword Integers
    ' 66 0F 38 3E PMAXUW xmm1, xmm2/m128 Maximum of Packed Unsigned Word Integers
    ' 66 0F 38 38 PMINSB xmm1, xmm2/m128 Minimum of Packed Signed Byte Integers
    ' 66 0F 38 39 PMINSD xmm1, xmm2/m128 Minimum of Packed Signed Dword Integers
    ' 66 0F 38 3B PMINUD xmm1, xmm2/m128 Minimum of Packed Unsigned Dword Integers
    ' 66 0F 38 3A PMINUW xmm1, xmm2/m128 Minimum of Packed Unsigned Word Integers
    ' 66 0F 38 21 PMOVSXBD xmm1, xmm2/m32 Packed Move with Sign Extend - Byte to Dword 
    ' 66 0F 38 22 PMOVSXBQ xmm1, xmm2/m16 Packed Move with Sign Extend - Byte to Qword
    ' 66 0F 38 20 PMOVSXBW xmm1, xmm2/m64 Packed Move with Sign Extend - Byte to Word
    ' 66 0F 38 23 PMOVSXWD xmm1, xmm2/m64 Packed Move with Sign Extend - Word to Dword
    ' 66 0F 38 24 PMOVSXWQ xmm1, xmm2/m32 Packed Move with Sign Extend - Word to Qword
    ' 66 0F 38 25 PMOVSXDQ xmm1, xmm2/m64 Packed Move with Sign Extend - Dword to Qword
    ' 66 0F 38 31 PMOVZXBD xmm1, xmm2/m32 Packed Move with Zero Extend - Byte to Dword
    ' 66 0F 38 32 PMOVZXBQ xmm1, xmm2/m16 Packed Move with Zero Extend - Byte to Qword
    ' 66 0F 38 30 PMOVZXBW xmm1,xmm2/m64 Packed Move with Zero Extend - Byte to Word
    ' 66 0F 38 33 PMOVZXWD xmm1, xmm2/m64 Packed Move with Zero Extend - Word to Dword
    ' 66 0F 38 34 PMOVZXWQ xmm1,xmm2/m32 Packed Move with Zero Extend - Word toQword
    ' 66 0F 38 35 PMOVZXDQ xmm1, xmm2/m64 Packed Move with Zero Extend - Dword to Qword
    ' 66 0F 38 28 PMULDQ xmm1, xmm2/m128 Multiply Packed Signed Dword Integers
    ' 66 0F 38 40 PMULLD xmm1, xmm2/m128 Multiply Packed Signed Dword Integers and Store Low Result
    ' 66 0F 38 17 PTEST xmm1, xmm2/m128 Logical Compare 
    ' 66 0F 3A 09 ROUNDPD xmm1, xmm2/m128, imm8 Round Packed Double Precision Floating-Point Values
    ' 66 0F 3A 08 ROUNDPS xmm1, xmm2/m128, imm8 Round Packed Single Precision Floating-Point Values
    ' 66 0F 3A 0B ROUNDSD xmm1, xmm2/m64, imm8 Round Scalar Double Precision Floating-Point Values
    ' 66 0F 3A 0A ROUNDSS xmm1, xmm2/m32, imm8 Round Scalar Single Precision Floating-Point Values


' 3DNOW


    ' dn postfix
    ' flt=3:pn=4:pfx=" 0f 0f":lp=1:b1=&h0a
    ' 0C PI2FW Packed Integer to Floating-Point Word Conversion
    ' 0D PI2FD Packed Integer to Floating-Point Doubleword Conversion
    ' 1C PF2IW Packed Floating-Point to Integer Word Conversion
    ' 1D PF2ID Packed Floating-Point to Integer Doubleword
    ' 8A PFNACC Packed Floating-Point Negative Accumulate
    ' 8E PFPNACC Packed Floating-Point Positive-Negative Accumulate
    ' 90 PFCMPGE Packed Floating-Point Compare Greater or Equal
    ' 94 PFMIN Packed Single-Precision Floating-Point Minimum
    ' 96 PFRCP Floating-Point Reciprocal Approximation
    ' 97 PFRSQRT Packed Floating-Point Reciprocal Square Root Approximation
    ' 9A PFSUB Packed Floating-Point Subtract
    ' 9E PFADD Packed Floating-Point Add
    ' A0 PFCMPGT Packed Floating-Point Compare Greater Than
    ' A4 PFMAX Packed Single-Precision Floating-Point Maximum
    ' A6 PFRCPIT1 Packed Floating-Point Reciprocal Iteration 1
    ' A7 PFRSQIT1 Packed Floating-Point Reciprocal Square Root Iteration 1
    ' AA PFSUBR Packed Floating-Point Subtract Reverse
    ' AE PFACC Packed Floating-Point Accumulate
    ' B0 PFCMPEQ Packed Floating-Point Compare Equal
    ' B4 PFMUL Packed Floating-Point Multiply
    ' B6 PFRCPIT2 Packed Floating-Point Reciprocal or Reciprocal Square Root Iteration 2
    ' B7 PMULHRW Packed Multiply High Rounded Word
    ' BB PSWAPD Packed Swap Doubleword
    ' BF PAVGUSB Packed Average Unsigned Bytes
 

    'CACHE MANAGEMENT
    ' 0f 40 PREFETCHT0  - Prefetch to all cache levels : 0f:c0:01 mem 
    ' 0f 80 PREFETCHT1  - Prefetch to all cache levels : 0f:c0:10 mem 
    ' 0f c0 PREFETCHT2  - Prefetch to L2 cache 0f:c0:c mem 
    ' 0f 00 PREFETCHNTA - Prefetch to L1 cache 0f:c0:00 mem Y 



    'BSWAP
    if wr="bswap" then
        wd=word(s,i)
        v=regid(wd,wk)
        if (v>=0)and(wk=4) then co=" 0F"+hexb(&hc8+v):goto addcode
        ers="Expecting 16/32 bit rigister":ert=16:goto exita
    end if


'=======================================================================================================
' OPERAND PROCESSING
'=======================================================================================================



other:
        ' ops prefix codes
        ' opd flags and opcodes
wr=ltrim$(rtrim$(wr))
        v=lookupc(wr)
        if ert then goto exita
        pfx=ops(v):lp=len(pfx)
        k=cast(long,@opd(v,0))
        ' assume row major order
        asm
            mov edx,[k]
            mov eax,[edx]
            mov [flt],eax
            mov eax,[edx+04]
            mov [pn],eax
            mov eax,[edx+08]
            mov [b1],eax
            mov eax,[edx+12]
            mov [c], eax
            mov eax,[edx+16]
            mov [ima],eax
            mov eax,[edx+20]
            mov [im],eax
            mov eax,[edx+24]
            mov [ic],eax
            mov eax,[edx+28]
            mov [dn],eax
        end asm
        if ima<1 then ima=0
        'print v,flt,pn,b1,c,ima,im,ic
        if (b1<0)and(ima<1)and(dn<0) then goto addcode ' no operands expected
        ' otherwise procede to mos


mos:
        a=asc(s,i)
        if (a<=13)or(a=39)or(a=59) then
            if pn=1 then ers="missing operand":ert=31:goto exita
            ers="missing operands":ert=31:goto exita
        end if

        wd=word(s,i):a=asc(wd)

        a=asc(s,i)
        if a=58 then
            i+=1
            'seg overrides
            k=-1
            if wd="cs" then k=&h2e
            if wd="ss" then k=&h36
            if wd="ds" then k=&h3e
            if wd="es" then k=&h26
            if wd="fs" then k=&h64
            if wd="gs" then k=&h65
            if k>=0 then pfx=hexb(k)+pfx:lp=1
            wd=word(s,i)
        end if
            
        v=regid(wd,wk)
        if v>=0 then
            if wk=2 then
                if flt>0 then ers="Can't use 16 bit register here":ert=12:goto exita
                pfx=" 66"+pfx:lp=1
            end if
            if flt=2 then ers="Can't use gp register with this mmx instruction":ert=3:goto exita
            if (flt=3)and(pn<>15) then
                if (b1<>&h50)and(im<>&hc5)and(im<>&hc4)and(b1<>&hd7) then
                    ers="Can't use gp register with this simd instruction":ert=3:goto exita
                end if
            end if
        end if
        if v<0 then
            if pn=14 then
                ers="Expecting a general reg followed by mm? ":ert=11:goto exita
            end if
            if flt>1 then 
                v=xmmxid(wd,wk)
                if v<0 then
                    if ima<1 then
                        if(a>44)and(a<58)and(a<>47) then ers="Not expecting a number": ert=31:goto exita
                    end if
                end if
            end if
            if (flt=0)and(v<0)and(lp=0) then
                v=sregid(wd,wk) ' with di
                if b1=&h88 then ' mov
                    if wk=129 then flt=0:b1=&h20: b0=&h0f ' to cr
                    if wk=130 then flt=0:b1=&h21: b0=&h0f ' to dr
                    if wk=131 then flt=0:b1=&h8c:         ' to segreg
                end if
                if sb=&h50 then ' push
                    if wk=131 then
                        if v=3 then co=" 1e"   :goto addcode ' ds
                        if v=1 then co=" 0e"   :goto addcode ' cs
                        if v=0 then co=" 06"   :goto addcode ' es
                        if v=2 then co=" 16"   :goto addcode ' ss
                        if v=4 then co=" 0F A0":goto addcode ' fs
                        if v=5 then co=" 0F A8":goto addcode ' gs
                    end if
                end if
                if sb=&h58 then ' pop
                    if wk=131 then
                        if v=3 then co=" 1f"   :goto addcode ' ds
                        if v=0 then co=" 07"   :goto addcode ' es
                        if v=2 then co=" 17"   :goto addcode ' ss
                        if v=4 then co=" 0F A1":goto addcode ' fs
                        if v=5 then co=" 0F A9":goto addcode ' gs
                    end if
                end if
            end if
        end if

'ACCUMMULATOR - MEM to EAX

        if (axdi>=0)and(flt=0) then
            if b1=-1 then
              b1=axdi: goto memoperand ' mul div idiv
            end if
            if pn=12 then
                a=asc(s,i)
                if a<>44 then ' single operand
                     b1=axdi:pn=1: goto memoperand ' imul
                end if                
                b0=&h0f:b1=&hac:im=&h69
            end if
        end if



'MEMORY AS FIRST OPERAND

memoperand:

        if v<0 then
            ' catch later
             if pn=5 then ers="Expecting a register":ert=31:goto exita
            ptf=0
            m=i
            wk=4 ' set as default
            a=0
            if flt=1 then
                if wd="word" then
                    if qt=1 then a=2
                    if qt=2 then a=2:ptf=1: b1+=6
                    if qt=4 then ers="'word' not supported for float types":ert=16:goto exita
                    if qt=5 then a=2:b1=&hdf ' fisttp
                end if
                if wd="dword" then
                    a=4:ptf=1
                    if qt=2 then b1+=2 ' f integer
                    if qt=5 then b1=&hdb ' fisttp
                end if
                if wd="qword" then
                    if qt=4 then a=8:ptf=1: b1+=4
                    if qt=5 then a=8:b1=&hdd ' fisttp
                    if qt=2 then
                        if itf=0 then ers="qword not supported here":ert=16:goto exita
                        a=8:ptf=1: b1+=6:c=itf
                    end if
                end if
                if wd="eword" then
                    if (et<0)or(qt=2)  then ers="eword not compatible here":ert=16:goto exita
                    a=10:ptf=1
                    if et>0 then b1+=2: c=et ' otherwise bbld or fbstp
                end if
                if (a=0)and(et<>0)and(qt<>1) then ers="Expect FPU type: word,dword,qword,eword ":ert=16:goto exita
            end if
            if flt=0 then
                if wd="dword" then a=4:ptf=1
                if wd="word"  then a=2:ptf=1
                if wd="byte"  then a=1:ptf=1
            end if
            if flt>1 then
                if instr(" word dword qword eword "," "+wd+" ")>0 then 
                    ers="MMX and SIMD instructions have implicit operand sizes":ert=31:goto exita
                end if
            end if
            if a then
                 wr=word(s,m)
                 if wr="ptr" then i=m
                 if wr="pointer" then i=m
                 wk=a:wd=word(s,i)
                 if (flt=0)and(pn<6)and(asc(wd)<>91) then
                     v=regid(wd,k) ' for movsx movzx options
                     if v>=0 then
                         if (wk>1)and(pn>2) then b1+=1
                         goto op1reg
                     end if
                 end if
            end if
            wk1=wk
            rg=c

            if wd="[" then
                if pn=3 then
                    if flt=2 then ers="Expecting mmx1..7 register first":ert=31:goto exita
                    if flt=3 then ers="Expecting xmm1..7 register first":ert=31:goto exita
                    ers="Expecting register first":ert=31:goto exita
                end if
                di=0:goto nextop
            end if
            if flt=1 then ers="Expecting '[..]'": ert=16: goto exita
            if pn=6 then ers="Expecting memory operand first [...],reg":ert=31:goto exita
            if pn=7 then ers="Expecting memory operand [...]":ert=31:goto exita
        end if


'IMMEDIATE AS FIRST OPERAND


        if v<0 then if pn=3 then ers="Expecting register first ":ert=31:goto exita
        if (v<0)and(ima>0) then
           if pn>1 then ers="Expecting  a register or [mem operand]":ert=31:goto exita
           a=asc(wd)
           if a=35 then
               ws=1
               co=" "+wd
           end if
           if a<>35 then
               wordval(s,swd,i,dv): if ert then goto exita
               v=dv
               ws=0
               if (v<-128)or(v>127) then ws=1
               if ws=0 then co=hexb(v)
               if ws=1 then co=hexl(v)
           end if
           if im=&h68 then
               ' immed push
               if ws=0 then b1=im+2 ' s
               if ws>0 then b1=im   ' w
               co=hexb(b1)+co:goto addcode
           end if
           'b1=im+ws
           'b2=md+ic*8+rg
           'co=hexb(b1)+hexb(b2)+co: goto addcode
           ers="This operand cannot be used in this position": ert=10:goto exita
        end if

'REGISTER AS FIRST OPERAND

op1reg:

        if v>=0 then
            rg=v
            if sb>0 then
                co=hexb(sb+rg): goto addcode
            end if
            if pn=1 then
                'inc dec push pop
                if (wk=1)or(wk=4) then
                    if (wk>1)and(flt=0) then b1 or = 1
                    ' push pop always 4
                    if b0>=0 then co=hexb(b0)
                    md=&hc0
                    b2=md+c*8+rg
                    co+=hexb(b1)+hexb(b2)
                    goto addcode
                end if
                if co="" then ers="Wrong operand size"+wd:ert=11: goto exita
            end if
            a=asc(s,i)
            if a<>44 then
                if pn=13 then 'implicit  ,1 shift
                    ws=0:if wk>1 then ws=1
                    co=hexb(b1+ws)+hexb(&hc0+c*8+rg)
                    goto addcode
                end if
                ers= "Expecting comma and operand": ert=10:goto exita
            end if
            i+=1 ' skip comma
            wk1=wk
            if (flt=0)and(pn<3) then di=2
            wd=word(s,i)
            a=asc(s,i)
            if a=58 then
                i+=1
                'seg overrides
                k=-1
                if wd="cs" then k=&h2e
                if wd="ss" then k=&h36
                if wd="ds" then k=&h3e
                if wd="es" then k=&h26
                if wd="fs" then k=&h64
                if wd="gs" then k=&h65
                if k>=0 then pfx=hexb(k)+pfx:lp=1
                wd=word(s,i)
            end if
            if wd="[" then
                if wk>128 then wk=1 ' segregs etc
                if pn=4 then ers="Second operand must be a register":ert=15:goto exita
                if pn=11 then ers="operand 2 must be a register,operand 3 is cl or 8 bit value ":ert=15:goto exita
                goto nextop
            end if

'REGISTER AS SECOND OPERAND

           rm=regid(wd,wk)
           if rm<0 then
                if flt>1 then rm=xmmxid(wd,wk)
                if pn=14 then
                    if rm>=0 then co=hexb(b1)+hexb(&hc0+rm*8+rg):goto addcode ' swapped over rm and rg
                    ers="Expecting general reg then mm? ":ert=11:goto exita
                end if
                if pn=15 then
                   'pextr
                   if asc(s,i)<>44 then ers="Expecting 8 bit value as third operand":ert=10:goto exita
                    i+=1:wd=word(s,i):v=val(wd)
                    if v>255 then ers="Expecting 8 bit value":ert=10:goto exita
                    b1=im:co=hexb(&hc0+rm*8+rg)+hexb(v):goto encode
                end if
            end if
            if (rm<0)and(b1=&h88)and(lp=0) then
                rm=sregid(wd,wk)
                if rm>=0 then
                    if wk1>=128 then ers="Expecting general purpose reg or mem [..]":ert=16:goto exita
                    v=sregid(wd,wk) ' with di
                    if wk=129 then b1=&h20: b0=&h0f ' from cr
                    if wk=130 then b1=&h21: b0=&h0f ' from  dr
                    if wk=131 then b1=&h8c:         ' from segreg
                    di=0:swap rg,rm
                end if
            end if
            if rm>=0 then

                if (wk>128)or(wk1>128) then wk=1:wk1=1
                if (wk1<>wk)and(pn=2) then 
                    if flt=0 then ers="Register size mismatch":ert=31:goto exita
                end if

                if (wk1<>4)and(wk<>2) then wk=1
                if (rsf<>0)and(wk<>0)and(rsf<>wk) then
                    if rsf=4 then ers="Not expecting 8 bit register":ert=31:goto exita
                    if rsf=1 then ers="Expecting 8 bit register":ert=31:goto exita
                end if
                ' data register direct
                if pn=13 then
                    if (rm<>1)and(wk<>1) then ers="Expecting cl register or shift 1..64 ":ert=15:goto exita
                    di=2
                    rm=rg:rg=c
                   if wk1>1 then b1 or = 1
                end if
                a=asc(s,i)
'THIRD IMMEDIATE OPERAND
                if (pn=10)or(pn=11)or(pn=12)or(pn=15) then
                    if a<>44 then ers="Expecting third operand":ert=16:goto exita
                    i+=1
                    wd=word(s,i)
                    v=val(wd)
                    di=0:wk=0:a=asc(wd)
                    if (v<>0)or(a=48) then 
                        b1=im
                        if pn<>12 then co=hexb(v)
                        if pn=12 then b0=-1:co=hexl(v)
                    end if
                    if (v=0)and(a<>48) then
                        if pn=10 then ers="Expecting an 8 bit value as third operand":ert=16:goto exita
                        if (wd<>"cl") then ers="Expecting cl register ":ert=16:goto exita
                    end if
                end if
                md=&hc0
                b1+=di
                if (pn=4)and(wk>1) then b1+=1
                b2=md+rg*8+rm
                co=hexb(b2)+co
                goto encode
            end if

'IMMEDIATE AS SECOND OPERAND

regimm:
            a=asc(wd)
            if v<0 then
                if ima<1 then
                    if(a>44)and(a<58)and(a<>47) then ers="Not expecting a number here": ert=31:goto exita
                end if
            end if
            if ima>0 then
                ws=0:se=0
                if a=35 then
                    'load immediate address
                    co=" "+wd
                    if wk1<4 then ers="#symbols only valid with 32+ bit regs":ert=11:goto exita
                    di=0:b1=im:wk=wk1
                    co=hexb(&hc0+ic*8+rg)+co
                    goto encode
                end if
                wordval(s,swd,i,dv): if ert then goto exita
                v=dv
                ws=0
                if (v<-128)or(v>255) then ws=1
                if ws=0 then co=hexb(v)
                if ws=1 then co=hexl(v)
                if (wk1=1)or(ima=8) then
                    if ws=1 then ers="Value out of range ":ert=12:goto exita
                    co=hexb(v)
                end if
                if (wk1>1)and(pn<3) then
                    ws=1:se=2 ' assume short sign extended
                    if (v<-128)or(v>127) then ws=1:se=0 ' long
                    if ima=2 then ws=1:se=0
                    if se=2 then co=hexb(v) ' 
                    if se=0 then
                        if wk1=2 then co=hexw(v)
                        if wk1=4 then co=hexl(v)
                    end if
                end if
                if wk1=2 then
                 if (dv>=2^16)or(dv<-2^15) then ers="Value out of range for 16 bit number":ert=10:goto exita
                end if
                if wk1=4 then
                 if (dv>=2^32)or(dv<-2^31) then ers="Value out of range for 32 bit number":ert=10:goto exita
                end if
                if pn=13 then
                    if (v<0)or(v>64) then ers=" bit-shift value out of range 1..32/64 ":ert=14:goto exita
                    b1=im:se=0:if wk1>1 then ws=1
                end if
                md=&hc0
                b1=im + se + ws
                b2=md+ic*8+rg
                co=hexb(b2)+co
                di=0:wk=0
                goto encode
            end if
            if asc(s,i)<>91 then ers="Can't identify next operand ' ":ert=11:goto exita
            goto nextop
        end if ' end of reg as first operand


'MEMORY AS FIRST OR SECOND OPERAND




nextop:

'-------------------
' [ebx+ecx*4+20],adx
'-------------------
if pn=14 then ers="Expecting reg,mmx not memory":ert=11:goto exita
if wd="[" then

    ads="":dss="":se=0:id=-1:sc=0:bs=-1:md=0

dreg1: ' FIRST REGISTER

    wd=word(s,i):a=asc(wd)
    if a=93 then ers="Empty [] ":ert=12:goto exita
    rm=regid(wd,nn)
    if rm<0 then
        rm=xmmxid(wd,nn)
        if rm<0 then rm=sregid(wd,nn)
        if rm>=0  then ers="mem operands require eax..edi registers":ert=13:goto exita
        goto doffs ' offset only
    end if
    if nn=1 then ers="Need 32 bit register": ert=12: goto exita
    wd=word(s,i):a=asc(wd)

' REGISTER OR OFFSET (SIB)

    if a=42 then id=rm:goto dscale ' id but no base
    if a=93 then goto dendbrak ' single reg only (no sib)
    if a=45 then wd+=word(s,i):goto doffs ' offset follows (base only)
    if a=43 then wd=word(s,i)

dreg2: 'SECOND REGISTER (SIB)

    re=regid(wd,nn)
    if re<0 then
        re=xmmxid(wd,nn)
        if re<0 then re=sregid(wd,nn)
        if re>=0  then ers="mem operands require eax..edi registers":ert=13:goto exita
        goto doffs
    end if
    if nn=1 then ers="Need 32bit register: ert=12: goto exita
    bs=rm ' base
    id=re ' index
    wd=word(s,i):a=asc(wd)
    if a=42 then goto dscale ' scale follows
    if a=45 then wd+=word(s,i):goto doffs ' offset follows -no scale
    if a=43 then wd=word(s,i): goto doffs ' offset follows -no scale    
    if a=93 then goto dendbrak

dscale: ' SCALE FOR SECOND REGISTER

    wd=word(s,i)
    sc=val(wd) ' literal scale
    k=0: if (sc=1)or(sc=2)or(sc=4)or(sc=8) then k=1
    if k=0 then ers="Invalid scale (1 2 4 8): "+str$(sc): ert=12: goto exita
    wd=word(s,i):a=asc(wd)
    if a=45 then wd+=word(s,i):goto doffs ' offset follows
    if a=43 then wd=word(s,i): goto doffs ' offset follows 
    goto dendbrak ' no offset

doffs: ' OFFSET

    a=asc(wd)
    if ((a>=48)and(a<=57))or(a=45) then
        v=val(wd)
        if (v>=-128)and(v<128) then md=&h40:ads=hexb(v)
        if (v<-128)or(v>127) then md=&h80: ads=hexl(v)
    end if
    ' short or long dsl
    if a=35 then
        ads=" "+wd
        md=&h80 ' bound literal
    end if
    wd=word(s,i) ' expecting ']'

dendbrak:

    if wd<>"]" then ert=12: ers="Expecting  ']' ":goto exita
    if asc(s,i)<>44 then
        if pn=13 then if wk1>1 then b1 or=1
        goto dexit ' b1 the same. assume ,1 for single bit shift
    end if
    i+=1
    wd=word(s,i)
    if (pn=1)or(di>0) then ers="comma found, surplus operand":ert=12: goto exita

secondop:

    v=regid(wd,wk)
    if v<0 then
        if flt>1 then 
            v=xmmxid(wd,wk)
            if v>=0 then
                ' reverse direction
                if (pn<>4)and(pn<>6) then
                    if flt=2 then b1+=16
                    if flt=3 then b1+=1
                end if
                if pn=15 then
                   'pextr
                   rg=v
                   if asc(s,i)<>44 then ers="Expecting 8 bit value as third operand":ert=10:goto exita
                    i+=1:wd=word(s,i):v=val(wd)
                    if v>255 then ers="Expecting 8 bit value":ert=10:goto exita
                    b1=im:dss=hexb(v):goto dexit
                end if
            end if
        end if
        if v<0 then if (pn=4)and(ima<1) then ers="Second operand must be a register":ert=15:goto exita
        if v<0 then if pn=11 then ers="Operand 2 must be a register, Op 3 is either cl or 8 bit value":ert=15:goto exita
        if (pn=10)or(pn=12)or(pn=15) then
            'third operand
            a=asc(s,i)
            v=val(wd)
            a=asc(wd)
            ws=0:wk=0
            if pn=12 then b0=-1:b1=im:dss=hexl(v):goto dexit
            if (V<>0)or(a=48) then b1=im:dss=hexb(v): goto dexit
            ers="Expecting an 8 bit value as third operand":ert=16:goto exita
        end if
        if (v<0)and(flt=0)and(b1=&h88)and(lp=0) then
            v=sregid(wd,wk)
            if v>=0 then
                if wk=131 then b1=&h8c:wk=1:wk1=1 ' from segreg
                if (wk=129)or(wk=130) then ers="These registers move to general purpose  regs only":ert=16:goto exita
            end if
        end if
    end if
    if v>=0 then
        if wk=2 then
            b0=&h66
            if flt>1 then ers="Cant use a 16 bit register here":ert=12:goto exita
        end if
        if ptf then if ima<>8 then ers=" word size is determined by register ":ert=13:goto exita
        if pn=13 then
            if (v<>1)and(wk<>1) then ers="Expecting cl register or shift 1..64 ":ert=15:goto exita
            wk=wk1
            if wk>1 then b1+=1
            di=2
            rg=c
            goto dexit
        end if
        rg=v
        wk1=wk
        if (pn=10)or(pn=11) then
            a=asc(s,i)
            if a<>44 then ers="Expecting third operand":ert=16:goto exita
            i+=1
            wd=word(s,i)
            v=val(wd)
            a=asc(wd)
            ws=0:wk=0
            if (V<>0)or(a=48) then b1=im:dss=hexb(v): goto dexit
            if pn=11 then if wd<>"cl" then ers="Expecting cl register (or 8 bit shift value)": ert=16: goto exita           
            goto dexit
        end if
        if (pn=4)and(wk>1) then b1+=1
        goto dexit
    end if

immedop:

    if ima<1 then ers="Must be a register ":ert=12:goto exita

    a=asc(wd)

    if a=35 then
       dss=" "+wd
       if wk1<4 then ers="#symbols only valid with 32+ bit operands":ert=11:goto exita
       ws=1: b1=im+ws:rg=ic: goto dexit
    end if

    wordval(s,swd,i,dv): if ert then goto exita
    v=dv

    if (v=0)and(a<>48) then
        'identify symbol
        '...
        ers="Unidentified imm symbol "+wd:ert=11: goto exita
    end if

    ws=0:se=0
    if (wk1=1)or(ima=8) then
        if (ws=1)or(a=35) then ers="Value out of range ":ert=12:goto exita
        co=hexb(v)
    end if

    if wk1=2 then
        if (dv>=2^16)or(dv<-2^15) then ers="Value out of range for 16 bit number":ert=10:goto exita
    end if
    if wk1=4 then
        if (dv>=2^32)or(dv<-2^31) then ers="Value out of range for 32 bit number":ert=10:goto exita
    end if

    rg=ic

    if (wk1>1)and(pn<3) then
        ws=1:se=2 ' assume short sign extended
        if (v<-128)or(v>127) then ws=1:se=0 ' long
        if ima=2 then ws=1:se=0
        if se=2 then co=hexb(v) ' 
        if se=0 then
            if wk1=2 then co=hexw(v)
            if wk1=4 then co=hexl(v)
        end if
    end if
    if wk1=8 then
        ers="Invalid ptr size: qword":ert=13:goto exita
    end if

    if wk1=10 then
        ers="Invalid ptr size: eword":ert=13:goto exita
    end if

    if pn=13 then
        if (v<0)or(v>64) then ers=" bit-shift value out of range 1..32/64 ":ert=14:goto exita
        ws=0:if wk1>1 then ws=1
        dss=hexb(v):b1=im+ws:goto dexit
    end if

    ' assume immediate value
    dss=co
    b1=im+ws+se
    '
dexit:

    a=asc(s,i):if a=44 then ers="Too many operands for this instruction": ert=10: goto exita

    if rm=04 then
        ' esp
        if id=4 then ers="Cant have scaled ESP ":ert=12: goto exita
        if id<0 then bs=04:id=04:sc=0 ' esp in sib with no index
    end if
    if rm=05 then
        'ebp only
        if (ads="")and(bs<0)and(id<0) then md=&h40:ads=" 00"
    end if
    if (len(ads)>0)and(rm<0) then md=0:rm=5 ' offset obly
    if (id>=0)and(bs<0)and(len(ads)>0) then ers="Must specify base reg when using an offset":ert=10:goto exita
    if (di=2)and(flt=0) then b1+=2 'is a first op with a reg source
    if (id>=0)or(bs>=0) then
        ' SIB
        if sc=1 then sc=&h00
        if sc=2 then sc=&h40
        if sc=4 then sc=&h80
        if sc=8 then sc=&hc0
        if bs=5 then
            if ads="" then md=&h40: ads=" 00" ' allow ebp as base register
        end if
        if (bs<0) then bs=5 ' assume no offset 
        if bs<0 then bs=0
        if id<0 then id=0
        sib=sc+id*8+bs
        rgm=md+rg*8+04
        co=hexb(rgm)+hexb(sib)+ads+dss
        goto encode
    end if
    ' NO SIB
    co=hexb(md+rg*8+rm)+ads+dss
    goto encode

end if   ' ....]

'---------------
'end of operands
'---------------

encode:

    if (flt=0)and(pn<3)and(wk>1) then b1=b1 or 1 ' word size ' alt pn<5

    if (co="")and(lp=0) then ers="Unidentified Operand or none":ert=12: goto exita
    co=hexb(b1)+co
    if b0>=0 then co=hexb(b0)+co: b0=-1
    if dn>=0 then co+=hexb(dn):dn=-1 '3dnow postfix

addcode:

    if lp then co=pfx+co:pfx="":lp=0

    ' now check for uninterpreted stuff



    if len(co)=0 then 
        if pn>0 then ers="Unresolved operand type "+wd:ert=15:goto exita
    end if

flush:

    m=0:b=1000:k=0
    do
        a=asc(s,i)
        if a=9 then a=32 ' tab ignore
        if a<=13 then exit do
        if (m=2)and(a>32) then
            ' compare code with commented code
            wd=word(s,i)
            v=val("&h"+wd)
            wd=word(co,b)
            if val("&h"+wd)<>v then k=1:m=1 'disagree
            continue do
        end if
        if m=1 then
            if a=33 then
                i+=1:a=asc(s,i)
                if a=63 then m=2:b=1:i+=1
                continue do
            end if
        end if
        if (a=39)or(a=59) then m=1
        if (a>32)and(m=0) then
            'j-=len(co)
            ers="Junk after instruction: "+mid$(s,bgl,i-bgl)
            ert=200:goto exita
        end if
        if a=9 then a=32 ' tab ignore
        if a<=13 then exit do
        i+=1
    loop
    if (k=1)or(b<=len(co)) then co+="; !! DISAGREE"


'ADD CODE LINE

    mid$(t,j)=co: j+=len(co) ' add code


    if vew=0 then wr=cr
    if vew>0 then
        a=i-bgl
       ' if a>32 then a=32 ' clip src comment
        wr=space$(32-len(co))+";  "+mid$(s,bgl,a)+cr ' append source as comment

        'clean off control chars
        v=0
        m=len(wr)-2
        do
            v+=1:if v>m then exit do
            a=asc(wr,v)
            if a=9 then a=32 ' tab ignore
            if a<32 then mid$(wr,v)=" "
        loop
    end if
    mid$(t,j)=wr:j+=len(wr)


exita:

    if ert>0 then
        if ert=25 then ers="malformed number (. point) "+wd
        if ert=26 then ers="malformed number (- sign) "+wd
        if ert=27 then ers="malformed number (E exponent) "+wd
        if ert=101 then ers="Macro undefined or out of scope:  "+wd
        if ert=102 then ers="Macro recursion suspected:  "+wd
        v=i
        do 'get while line
            a=asc(s,v)
            if a=9 then a=32 ' tab ignore
            if a<=13 then exit do
            if v-i>255 then exit do
            v+=1
        loop
        k=i
        'skip to end of line
        do
            a=asc(s,i)
            if a=9 then a=32 ' ignore tab
            if (a<=13) then exit do
            i+=1
        loop
        ers=" ; "+mid$(s,bgl,i-bgl)+" !! "+ers+cr
        if vew<2 then i=k: exit do
        if vew=2 then mid$(t,j)=ers: j+=len(ers)
        ert=0
        b0=-1
        b1=-1
        b2=-1
        dn=-1
        lp=0
        pfx=""
    end if


    a=len(t): if j>a-200 then t+=space$(1000)

loop ' main loop
'
'------
'FINISH
'------

term:

    if (ert=0)and(rtf=0) then ers="Missing ret":ert=20
    t=left$(t,j-1)
    if brc>0 then ers="Too many left brackets in source ((..) ":ert=10
    if ert=0 then if len(t)=0 then ers="Empty":ert=10
    if ert>0 then
        if vew=0 then t="c3"
        'if vew>0 then t+=ers
    end if
    function=t
end function
